/*      Compiler: ECL 24.5.10                                         */
/*      Source: /builddir/build/BUILD/ecl-24.5.10-build/ecl-24.5.10/src/cmp/cmpbackend-cxx/cmpbackend-cxx.lsp */
#include <ecl/ecl-cmp.h>
#include "cmp/cmpbackend-cxx.eclh"
/*      function definition for SAFE-MKSTEMP                          */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3846safe_mkstemp(cl_object v1template)
{
 cl_object T0, T1, T2;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v2base;
   v2base = si_mkstemp(v1template);
   if ((v2base)!=ECL_NIL) { goto L2; }
   cl_error(2, VV[0], v1template);
L2:;
   {
    cl_object v3output;
    T0 = cl_pathname_name(1, v2base);
    value0 = cl_pathname_type(1, v2base);
    if ((value0)!=ECL_NIL) { goto L8; }
    T1 = VV[1];
    goto L6;
L8:;
    T1 = value0;
    goto L6;
L6:;
    T2 = cl_concatenate(3, ECL_SYM("STRING",807), T0, T1);
    v3output = cl_make_pathname(6, ECL_SYM("NAME",1306), T2, ECL_SYM("TYPE",1353), VV[2], ECL_SYM("DEFAULTS",1244), v2base);
    if ((cl_probe_file(v3output))!=ECL_NIL) { goto L10; }
    if (Null(si_copy_file(v2base, v3output))) { goto L10; }
    T0 = cl_truename(v3output);
    T1 = cl_truename(v2base);
    v2base = cl_list(2, T0, T1);
    goto L4;
L10:;
    cl_delete_file(v2base);
    v2base = ECL_NIL;
   }
L4:;
   value0 = v2base;
   cl_env_copy->nvalues = 1;
   return value0;
  }
 }
}
/*      function definition for CMP-DELETE-FILE                       */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3847cmp_delete_file(cl_object v1file)
{
 cl_object T0;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v2;
   v2 = ecl_make_bool(ecl_symbol_value(VV[4])==ECL_NIL);
   if (Null(v2)) { goto L2; }
   value0 = v2;
   cl_env_copy->nvalues = 1;
   return value0;
L2:;
   {
    cl_object v3;
    v3 = si_getenv(VV[5]);
    if (Null(v3)) { goto L5; }
    value0 = v3;
    cl_env_copy->nvalues = 1;
    return value0;
L5:;
    {
     cl_object v4;
     T0 = cl_probe_file(v1file);
     v4 = ecl_make_bool(T0==ECL_NIL);
     if (Null(v4)) { goto L8; }
     value0 = v4;
     cl_env_copy->nvalues = 1;
     return value0;
L8:;
     if (Null(ecl_symbol_value(VV[6]))) { goto L10; }
     ecl_function_dispatch(cl_env_copy,VV[146])(2, VV[7], v1file) /*  CMPPROGRESS */;
     cl_set(VV[8],CONS(v1file,ecl_symbol_value(VV[8])));
     value0 = ecl_symbol_value(VV[8]);
     cl_env_copy->nvalues = 1;
     return value0;
L10:;
     value0 = cl_delete_file(v1file);
     return value0;
    }
   }
  }
 }
}
/*      local function LAMBDA7                                        */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC3848__lambda7()
{
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v1;
   v1 = (ECL_SYM("DELETE-FILE",295)->symbol.gfdef);
   {
    cl_object v2;
    v2 = ecl_symbol_value(VV[8]);
    {
     cl_object v3;
     cl_object v4;
     v3 = ECL_NIL;
     {
      cl_object v5;
      v5 = v2;
      if (ecl_unlikely(!ECL_LISTP(v5))) FEtype_error_list(v5);
      value0 = ECL_NIL;
      cl_env_copy->nvalues = 0;
      v4 = v5;
     }
L7:;
     if (!(ecl_endp(v4))) { goto L9; }
     goto L8;
L9:;
     v3 = ECL_CONS_CAR(v4);
     {
      cl_object v5;
      v5 = ECL_CONS_CDR(v4);
      if (ecl_unlikely(!ECL_LISTP(v5))) FEtype_error_list(v5);
      value0 = ECL_NIL;
      cl_env_copy->nvalues = 0;
      v4 = v5;
     }
     ecl_function_dispatch(cl_env_copy,v1)(1, v3);
     goto L7;
L8:;
     value0 = v2;
     cl_env_copy->nvalues = 1;
     return value0;
    }
   }
  }
 }
}
/*      local function FIX-FOR-MINGW                                  */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC3849fix_for_mingw(cl_object v1, cl_object v2)
{
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4directory_namestring;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   ecl_function_dispatch(cl_env_copy,VV[148])(1, v1) /*  DM-TOO-FEW-ARGUMENTS */;
L3:;
   {
    cl_object v5;
    v5 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4directory_namestring = v5;
   }
   if (Null(v3)) { goto L8; }
   ecl_function_dispatch(cl_env_copy,VV[149])(1, v1) /*  DM-TOO-MANY-ARGUMENTS */;
L8:;
   value0 = v4directory_namestring;
   cl_env_copy->nvalues = 1;
   return value0;
  }
 }
}
/*      function definition for GET-DEPRECATED-USER-LD-FLAGS          */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3850get_deprecated_user_ld_flags()
{
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v1flags;
   v1flags = ecl_function_dispatch(cl_env_copy,VV[151])(1, ecl_symbol_value(VV[11])) /*  SPLIT-PROGRAM-OPTIONS */;
   if (Null(v1flags)) { goto L2; }
   ecl_function_dispatch(cl_env_copy,VV[152])(4, VV[12], VV[11], VV[13], VV[14]) /*  CMPWARN */;
L2:;
   value0 = v1flags;
   cl_env_copy->nvalues = 1;
   return value0;
  }
 }
}
/*      function definition for LINKER-CC                             */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3851linker_cc(cl_narg narg, cl_object v1o_pathname, cl_object v2object_files, ...)
{
 cl_object T0, T1, T2, T3, T4, T5, T6, T7, T8, T9;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 if (ecl_unlikely(narg<2)) FEwrong_num_arguments_anonym();
 {
  cl_object v3type;
  cl_object v4ld_flags;
  cl_object v5ld_libs;
  ecl_va_list args; ecl_va_start(args,v2object_files,narg,2);
  {
   cl_object keyvars[6];
   cl_parse_key(args,3,L3851linker_cckeys,keyvars,NULL,FALSE);
   ecl_va_end(args);
   if (Null(keyvars[3])) {
    v3type = VV[16];
   } else {
    v3type = keyvars[0];
   }
   if (Null(keyvars[4])) {
    if (!((v3type)==(VV[16]))) { goto L4; }
    T0 = ecl_symbol_value(VV[17]);
    goto L3;
L4:;
    T0 = ecl_symbol_value(VV[18]);
L3:;
    v4ld_flags = ecl_function_dispatch(cl_env_copy,VV[151])(1, T0) /*  SPLIT-PROGRAM-OPTIONS */;
   } else {
    v4ld_flags = keyvars[1];
   }
   if (Null(keyvars[5])) {
    v5ld_libs = ecl_function_dispatch(cl_env_copy,VV[151])(1, ecl_symbol_value(VV[19])) /*  SPLIT-PROGRAM-OPTIONS */;
   } else {
    v5ld_libs = keyvars[2];
   }
  }
  T0 = ecl_symbol_value(VV[20]);
  T1 = ecl_function_dispatch(cl_env_copy,VV[157])(1, v1o_pathname) /*  BRIEF-NAMESTRING */;
  T2 = L3860ecl_library_directory();
  T3 = cl_concatenate(3, ECL_SYM("STRING",807), VV[22], T2);
  T4 = ecl_function_dispatch(cl_env_copy,VV[151])(1, ecl_symbol_value(VV[13])) /*  SPLIT-PROGRAM-OPTIONS */;
  if (Null(ecl_symbol_value(VV[23]))) { goto L9; }
  T5 = ecl_list1(ecl_symbol_value(VV[23]));
  goto L7;
L9:;
  T5 = ECL_NIL;
  goto L7;
L7:;
  T6 = ecl_function_dispatch(cl_env_copy,VV[151])(1, ecl_symbol_value(VV[14])) /*  SPLIT-PROGRAM-OPTIONS */;
  T7 = L3850get_deprecated_user_ld_flags();
  T8 = cl_append(7, T4, v4ld_flags, v2object_files, T5, T6, T7, v5ld_libs);
  T9 = cl_listX(4, VV[21], T1, T3, T8);
  value0 = ecl_function_dispatch(cl_env_copy,VV[158])(2, T0, T9) /*  SAFE-RUN-PROGRAM */;
  return value0;
 }
}
/*      function definition for LINKER-AR                             */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3852linker_ar(cl_object v1output_name, cl_object v2o_name, cl_object v3ld_libs)
{
 cl_object T0, T1, T2;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  T0 = cl_namestring(v1output_name);
  T1 = ecl_function_dispatch(cl_env_copy,VV[157])(1, v2o_name) /*  BRIEF-NAMESTRING */;
  T2 = CONS(T1,v3ld_libs);
  value0 = L3853static_lib_ar(T0, T2);
  return value0;
 }
}
/*      function definition for STATIC-LIB-AR                         */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3853static_lib_ar(cl_object v1lib, cl_object v2object_files)
{
 cl_object T0, T1, T2, T3;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3lib;
   v3lib = ecl_function_dispatch(cl_env_copy,VV[157])(1, v1lib) /*  BRIEF-NAMESTRING */;
   if (Null(cl_probe_file(v3lib))) { goto L2; }
   cl_delete_file(v3lib);
L2:;
   T0 = ecl_symbol_value(VV[26]);
   {
    cl_object v4;
    v4 = ecl_fdefinition(VV[157]);
    {
     cl_object v5;
     cl_object v6;
     v5 = ECL_NIL;
     {
      cl_object v7;
      v7 = v2object_files;
      if (ecl_unlikely(!ECL_LISTP(v7))) FEtype_error_list(v7);
      value0 = ECL_NIL;
      cl_env_copy->nvalues = 0;
      v6 = v7;
     }
     {
      cl_object v7;
      cl_object v8;
      v7 = ecl_list1(ECL_NIL);
      v8 = v7;
L13:;
      if (!(ecl_endp(v6))) { goto L15; }
      goto L14;
L15:;
      v5 = ECL_CONS_CAR(v6);
      {
       cl_object v9;
       v9 = ECL_CONS_CDR(v6);
       if (ecl_unlikely(!ECL_LISTP(v9))) FEtype_error_list(v9);
       value0 = ECL_NIL;
       cl_env_copy->nvalues = 0;
       v6 = v9;
      }
      {
       cl_object v9;
       v9 = v8;
       if (ecl_unlikely(ECL_ATOM(v9))) FEtype_error_cons(v9);
       value0 = ECL_NIL;
       cl_env_copy->nvalues = 0;
       T2 = v9;
      }
      T3 = ecl_function_dispatch(cl_env_copy,v4)(1, v5);
      v8 = ecl_list1(T3);
      (ECL_CONS_CDR(T2)=v8,T2);
      goto L13;
L14:;
      T1 = ecl_cdr(v7);
      goto L5;
     }
    }
   }
L5:;
   T2 = cl_listX(3, VV[27], v3lib, T1);
   ecl_function_dispatch(cl_env_copy,VV[158])(2, T0, T2) /*  SAFE-RUN-PROGRAM */;
   T0 = ecl_list1(v3lib);
   value0 = ecl_function_dispatch(cl_env_copy,VV[158])(2, ecl_symbol_value(VV[28]), T0) /*  SAFE-RUN-PROGRAM */;
   return value0;
  }
 }
}
/*      function definition for COMPILER-CC                           */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3854compiler_cc(cl_object v1c_pathname, cl_object v2o_pathname)
{
 cl_object T0, T1, T2, T3, T4, T5, T6, T7, T8, T9, T10, T11, T12, T13, T14, T15;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  T0 = ecl_symbol_value(VV[30]);
  T1 = L3857precompiled_header_flags();
  T2 = L3859ecl_include_directory();
  T3 = cl_concatenate(3, ECL_SYM("STRING",807), VV[32], T2);
  T4 = ecl_function_dispatch(cl_env_copy,VV[151])(1, ecl_symbol_value(VV[33])) /*  SPLIT-PROGRAM-OPTIONS */;
  T6 = ecl_function_dispatch(cl_env_copy,VV[162])(1, ECL_SYM("SPEED",793)) /*  CMP-ENV-OPTIMIZATION */;
  if (!(ecl_greatereq(T6,ecl_make_fixnum(2)))) { goto L3; }
  T5 = ecl_function_dispatch(cl_env_copy,VV[151])(1, ecl_symbol_value(VV[34])) /*  SPLIT-PROGRAM-OPTIONS */;
  goto L1;
L3:;
  T5 = ECL_NIL;
  goto L1;
L1:;
  T6 = ecl_function_dispatch(cl_env_copy,VV[157])(1, v1c_pathname) /*  BRIEF-NAMESTRING */;
  T7 = ecl_function_dispatch(cl_env_copy,VV[157])(1, v2o_pathname) /*  BRIEF-NAMESTRING */;
  T8 = cl_list(2, VV[21], T7);
  T9 = ecl_function_dispatch(cl_env_copy,VV[151])(1, ecl_symbol_value(VV[36])) /*  SPLIT-PROGRAM-OPTIONS */;
  T10 = ecl_append(T8,T9);
  T11 = cl_listX(3, VV[35], T6, T10);
  T12 = cl_append(3, T4, T5, T11);
  T13 = CONS(T3,T12);
  T14 = ecl_append(T1,T13);
  T15 = CONS(VV[31],T14);
  value0 = ecl_function_dispatch(cl_env_copy,VV[158])(2, T0, T15) /*  SAFE-RUN-PROGRAM */;
  return value0;
 }
}
/*      function definition for NEED-TO-DUMP-PRECOMPILED-HEADER       */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3855need_to_dump_precompiled_header()
{
 cl_object T0, T1;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v1config;
   cl_object v2need_to_dump;
   v1config = ecl_symbol_value(VV[38]);
   value0 = ecl_make_bool(v1config==ECL_NIL);
   if ((value0)!=ECL_NIL) { goto L4; }
   T0 = ecl_aref1(v1config,0);
   {
    bool v3;
    v3 = (T0)==(ecl_symbol_value(VV[30]));
    value0 = (v3)?ECL_NIL:ECL_T;
   }
   if ((value0)!=ECL_NIL) { goto L4; }
   T0 = ecl_aref1(v1config,1);
   T1 = L3859ecl_include_directory();
   {
    bool v3;
    v3 = (T0)==(T1);
    value0 = (v3)?ECL_NIL:ECL_T;
   }
   if ((value0)!=ECL_NIL) { goto L4; }
   T0 = ecl_aref1(v1config,2);
   {
    bool v3;
    v3 = (T0)==(ecl_symbol_value(VV[33]));
    value0 = (v3)?ECL_NIL:ECL_T;
   }
   if ((value0)!=ECL_NIL) { goto L4; }
   T0 = ecl_aref1(v1config,3);
   {
    bool v3;
    v3 = (T0)==(ecl_symbol_value(VV[34]));
    value0 = (v3)?ECL_NIL:ECL_T;
   }
   if ((value0)!=ECL_NIL) { goto L4; }
   T0 = ecl_aref1(v1config,4);
   {
    bool v3;
    v3 = (T0)==(ecl_symbol_value(VV[36]));
    v2need_to_dump = (v3)?ECL_NIL:ECL_T;
    goto L2;
   }
L4:;
   v2need_to_dump = value0;
   goto L2;
L2:;
   if (Null(v2need_to_dump)) { goto L10; }
   T0 = ecl_symbol_value(VV[30]);
   T1 = L3859ecl_include_directory();
   cl_set(VV[38],cl_vector(5, T0, T1, ecl_symbol_value(VV[33]), ecl_symbol_value(VV[34]), ecl_symbol_value(VV[36])));
L10:;
   value0 = v2need_to_dump;
   cl_env_copy->nvalues = 1;
   return value0;
  }
 }
}
/*      function definition for PRECOMPILED-HEADER-FLAGS              */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3857precompiled_header_flags()
{
 cl_object T0, T1, T2, T3;
 cl_object volatile env0 = ECL_NIL;
 cl_object volatile CLV0, CLV1;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object volatile value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  if (Null(ecl_symbol_value(VV[40]))) { goto L1; }
  if (Null(L3855need_to_dump_precompiled_header())) { goto L3; }
  {
   volatile cl_object env1 = env0;
   env1 = ECL_NIL;
   CLV0 = env1 = CONS(ECL_NIL,env1);
   {
    volatile cl_object env2 = env1;
    CLV1 = env2 = CONS(ECL_NEW_FRAME_ID(cl_env_copy),env2); /*  TAGBODY */
    {
     ecl_frs_push(cl_env_copy,ECL_CONS_CAR(CLV1));
     if (__ecl_frs_push_result) {
     if (cl_env_copy->values[0]==ecl_make_fixnum(0))goto L5;
     ecl_internal_error("GO found an inexistent tag");
     }
    }
    {
     cl_object v1;
     v1 = ecl_make_cclosure_va((cl_objectfn)LC3856__lambda32,env2,Cblock,1);
     T0 = v1;
    }
    T1 = CONS(ECL_SYM("ERROR",339),T0);
    T2 = ecl_list1(T1);
    T3 = CONS(T2,ecl_symbol_value(ECL_SYM("*HANDLER-CLUSTERS*",6)));
    ecl_bds_bind(cl_env_copy,ECL_SYM("*HANDLER-CLUSTERS*",6),T3); /*  *HANDLER-CLUSTERS* */
    L3858dump_precompiled_header();
    ecl_frs_pop(cl_env_copy);
    ecl_bds_unwind1(cl_env_copy);
    goto L3;
L5:;
    {
     cl_object v1err;
     v1err = ECL_CONS_CAR(CLV0);
     cl_set(VV[40],ECL_NIL);
     cl_set(VV[41],ECL_NIL);
     cl_set(VV[38],ECL_NIL);
     ecl_function_dispatch(cl_env_copy,VV[165])(2, VV[42], v1err) /*  CMPNOTE */;
     ecl_frs_pop(cl_env_copy);
     goto L3;
    }
   }
  }
L3:;
  value0 = ecl_symbol_value(VV[41]);
  cl_env_copy->nvalues = 1;
  return value0;
L1:;
  value0 = ECL_NIL;
  cl_env_copy->nvalues = 1;
  return value0;
 }
}
/*      closure LAMBDA32                                              */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC3856__lambda32(cl_narg narg, cl_object v1si__temp, ...)
{
 cl_object CLV0, CLV1;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object env0 = cl_env_copy->function->cclosure.env;
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 /* Scanning closure data ... */
 CLV1 = env0;                                     /*  TAGBODY         */
 CLV0 = _ecl_cdr(CLV1);
 { /* ... closure scanning finished */
 if (ecl_unlikely(narg!=1)) FEwrong_num_arguments_anonym();
 {
TTL:
  ECL_CONS_CAR(CLV0) = v1si__temp;
  cl_go(ECL_CONS_CAR(CLV1),ecl_make_fixnum(0));
 }
 }
}
/*      function definition for DUMP-PRECOMPILED-HEADER               */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3858dump_precompiled_header()
{
 cl_object T0, T1, T2, T3, T4, T5, T6, T7, T8, T9, T10;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v1input_file;
   cl_object v2output_dir;
   cl_object v3output_file;
   T0 = L3859ecl_include_directory();
   T1 = cl_pathname_directory(1, T0);
   T2 = ecl_append(T1,VV[44]);
   T3 = L3859ecl_include_directory();
   v1input_file = cl_make_pathname(8, ECL_SYM("DIRECTORY",1247), T2, ECL_SYM("DEFAULTS",1244), T3, ECL_SYM("NAME",1306), VV[45], ECL_SYM("TYPE",1353), VV[46]);
   T0 = cl_random(1, ecl_make_fixnum(65535));
   T1 = cl_format(3, ECL_NIL, VV[47], T0);
   T2 = cl_translate_logical_pathname(1, VV[48]);
   v2output_dir = cl_merge_pathnames(2, T1, T2);
   T0 = cl_make_pathname(4, ECL_SYM("NAME",1306), VV[45], ECL_SYM("DEFAULTS",1244), v2output_dir);
   v3output_file = (cl_env_copy->function=(ECL_SYM("COMPILE-FILE-PATHNAME",237)->symbol.gfdef))->cfun.entry(3, T0, ECL_SYM("TYPE",1353), VV[49]) /*  COMPILE-FILE-PATHNAME */;
   cl_ensure_directories_exist(1, v2output_dir);
   cl_set(VV[8],CONS(v2output_dir,ecl_symbol_value(VV[8])));
   T0 = ecl_symbol_value(VV[30]);
   T1 = cl_namestring(v1input_file);
   T2 = L3859ecl_include_directory();
   T3 = cl_concatenate(3, ECL_SYM("STRING",807), VV[32], T2);
   T4 = ecl_function_dispatch(cl_env_copy,VV[151])(1, ecl_symbol_value(VV[33])) /*  SPLIT-PROGRAM-OPTIONS */;
   T5 = ecl_function_dispatch(cl_env_copy,VV[151])(1, ecl_symbol_value(VV[34])) /*  SPLIT-PROGRAM-OPTIONS */;
   T6 = cl_namestring(v3output_file);
   T7 = ecl_function_dispatch(cl_env_copy,VV[151])(1, ecl_symbol_value(VV[36])) /*  SPLIT-PROGRAM-OPTIONS */;
   T8 = cl_listX(3, VV[21], T6, T7);
   T9 = cl_append(3, T4, T5, T8);
   T10 = cl_listX(5, VV[50], VV[51], T1, T3, T9);
   ecl_function_dispatch(cl_env_copy,VV[158])(2, T0, T10) /*  SAFE-RUN-PROGRAM */;
   cl_set(VV[8],CONS(v3output_file,ecl_symbol_value(VV[8])));
   T0 = cl_namestring(v2output_dir);
   T1 = cl_concatenate(3, ECL_SYM("STRING",807), VV[32], T0);
   T2 = cl_namestring(v2output_dir);
   T3 = cl_concatenate(3, ECL_SYM("STRING",807), T2, VV[53]);
   cl_set(VV[41],cl_list(3, T1, VV[52], T3));
   value0 = ecl_symbol_value(VV[41]);
   cl_env_copy->nvalues = 1;
   return value0;
  }
 }
}
/*      function definition for ECL-INCLUDE-DIRECTORY                 */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3859ecl_include_directory()
{
 cl_object T0;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  if (Null(ecl_symbol_value(VV[55]))) { goto L1; }
  T0 = cl_merge_pathnames(2, VV[56], ecl_symbol_value(VV[55]));
  if (Null(cl_probe_file(T0))) { goto L1; }
  value0 = ecl_symbol_value(VV[55]);
  cl_env_copy->nvalues = 1;
  return value0;
L1:;
  if (Null(cl_probe_file(VV[57]))) { goto L4; }
  T0 = cl_translate_logical_pathname(1, VV[58]);
  cl_set(VV[55],cl_namestring(T0));
  value0 = ecl_symbol_value(VV[55]);
  cl_env_copy->nvalues = 1;
  return value0;
L4:;
  {
   cl_object v1;
   v1 = cl_error(1, VV[59]);
   if (Null(v1)) { goto L8; }
   value0 = v1;
   cl_env_copy->nvalues = 1;
   return value0;
L8:;
   value0 = ECL_NIL;
   cl_env_copy->nvalues = 1;
   return value0;
  }
 }
}
/*      function definition for ECL-LIBRARY-DIRECTORY                 */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3860ecl_library_directory()
{
 cl_object T0, T1;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  if (Null(ecl_symbol_value(VV[61]))) { goto L1; }
  T0 = (cl_env_copy->function=(ECL_SYM("COMPILE-FILE-PATHNAME",237)->symbol.gfdef))->cfun.entry(3, VV[62], ECL_SYM("TYPE",1353), VV[63]) /*  COMPILE-FILE-PATHNAME */;
  T1 = cl_merge_pathnames(2, T0, ecl_symbol_value(VV[61]));
  if (Null(cl_probe_file(T1))) { goto L1; }
  value0 = ecl_symbol_value(VV[61]);
  cl_env_copy->nvalues = 1;
  return value0;
L1:;
  if (Null(cl_probe_file(VV[64]))) { goto L4; }
  T0 = cl_translate_logical_pathname(1, VV[58]);
  cl_set(VV[61],cl_namestring(T0));
  value0 = ecl_symbol_value(VV[61]);
  cl_env_copy->nvalues = 1;
  return value0;
L4:;
  {
   cl_object v1;
   v1 = cl_error(1, VV[65]);
   if (Null(v1)) { goto L8; }
   value0 = v1;
   cl_env_copy->nvalues = 1;
   return value0;
L8:;
   value0 = ECL_NIL;
   cl_env_copy->nvalues = 1;
   return value0;
  }
 }
}
/*      function definition for GUESS-KIND                            */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3861guess_kind(cl_object v1pathname)
{
 cl_object T0;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v2record;
   {
    cl_object v3;
    cl_object v4;
    v3 = cl_pathname_type(1, v1pathname);
    v4 = (ECL_SYM("STRING-EQUAL",810)->symbol.gfdef);
    {
     cl_object v5;
     v5 = VV[67];
     goto L7;
L6:;
     {
      cl_object v6;
      cl_object v7;
      {
       cl_object v8;
       v8 = v5;
       if (ecl_unlikely(ECL_ATOM(v8))) FEtype_error_cons(v8);
       value0 = ECL_NIL;
       cl_env_copy->nvalues = 0;
       v6 = v8;
      }
      v7 = ECL_CONS_CAR(v6);
      if (Null(v7)) { goto L9; }
      {
       cl_object v8;
       {
        cl_object v9;
        v9 = v7;
        if (ecl_unlikely(ECL_ATOM(v9))) FEtype_error_cons(v9);
        value0 = ECL_NIL;
        cl_env_copy->nvalues = 0;
        T0 = v9;
       }
       v8 = ECL_CONS_CAR(T0);
       if (Null(cl_string_equal(2, v3, v8))) { goto L9; }
       v2record = v7;
       goto L1;
      }
     }
L9:;
     v5 = ECL_CONS_CDR(v5);
L7:;
     if (v5==ECL_NIL) { goto L22; }
     goto L6;
L22:;
     v2record = ECL_NIL;
    }
   }
L1:;
   if (Null(v2record)) { goto L24; }
   value0 = ecl_cadr(v2record);
   cl_env_copy->nvalues = 1;
   return value0;
L24:;
   (cl_env_copy->function=(ECL_SYM("WARN",905)->symbol.gfdef))->cfun.entry(2, VV[68], v1pathname) /*  WARN */;
   value0 = ECL_SYM("OBJECT",1312);
   cl_env_copy->nvalues = 1;
   return value0;
  }
 }
}
/*      function definition for GUESS-LD-LIBS                         */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3862guess_ld_libs(cl_narg narg, cl_object v1pathname, ...)
{
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 if (ecl_unlikely(narg<1)) FEwrong_num_arguments_anonym();
 {
  cl_object v2kind;
  ecl_va_list args; ecl_va_start(args,v1pathname,narg,1);
  {
   cl_object keyvars[2];
   cl_parse_key(args,1,L3862guess_ld_libskeys,keyvars,NULL,FALSE);
   ecl_va_end(args);
   if (Null(keyvars[1])) {
    v2kind = L3861guess_kind(v1pathname);
   } else {
    v2kind = keyvars[0];
   }
  }
  if (!((v2kind)==(ECL_SYM("OBJECT",1312)))) { goto L7; }
  goto L4;
  goto L5;
L7:;
  goto L5;
L5:;
  if (!((v2kind)==(VV[71]))) { goto L2; }
  goto L3;
L4:;
L3:;
  value0 = ecl_function_dispatch(cl_env_copy,VV[157])(1, v1pathname) /*  BRIEF-NAMESTRING */;
  return value0;
L2:;
  if (!((v2kind)==(VV[74]))) { goto L15; }
  goto L12;
  goto L13;
L15:;
  goto L13;
L13:;
  if (!((v2kind)==(VV[75]))) { goto L10; }
  goto L11;
L12:;
L11:;
  value0 = ECL_NIL;
  cl_env_copy->nvalues = 1;
  return value0;
L10:;
  if (!((v2kind)==(VV[78]))) { goto L23; }
  goto L20;
  goto L21;
L23:;
  goto L21;
L21:;
  if (!((v2kind)==(VV[79]))) { goto L18; }
  goto L19;
L20:;
L19:;
  value0 = ecl_function_dispatch(cl_env_copy,VV[157])(1, v1pathname) /*  BRIEF-NAMESTRING */;
  return value0;
L18:;
  if (!((v2kind)==(VV[63]))) { goto L31; }
  goto L28;
  goto L29;
L31:;
  goto L29;
L29:;
  if (!((v2kind)==(VV[82]))) { goto L26; }
  goto L27;
L28:;
L27:;
  value0 = ecl_function_dispatch(cl_env_copy,VV[157])(1, v1pathname) /*  BRIEF-NAMESTRING */;
  return value0;
L26:;
  if (!((v2kind)==(VV[16]))) { goto L34; }
  value0 = ECL_NIL;
  cl_env_copy->nvalues = 1;
  return value0;
L34:;
  value0 = cl_error(2, VV[85], v2kind);
  return value0;
 }
}
/*      function definition for SYSTEM-LD-FLAG                        */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3869system_ld_flag(cl_object v1library)
{
 volatile cl_object lex0[2];
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
  lex0[0] = v1library;                            /*  LIBRARY         */
TTL:
  {
   cl_object v2system;
   lex0[1] = ECL_NIL;                             /*  ASDF            */
   v2system = ECL_NIL;
   if (Null(lex0[1])) { goto L6; }
   v2system = LC3864asdfcall(3, lex0, VV[90], lex0[0], ECL_NIL);
   if (Null(v2system)) { goto L6; }
   value0 = LC3867find_archive(lex0, v2system);
   goto L4;
L6:;
   value0 = ECL_NIL;
   goto L4;
L4:;
   if ((value0)!=ECL_NIL) { goto L3; }
   value0 = LC3868fallback(lex0);
   return value0;
L3:;
   cl_env_copy->nvalues = 1;
   return value0;
  }
 }
}
/*      local function FALLBACK                                       */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC3868fallback(volatile cl_object *lex0)
{
 cl_object T0, T1, T2;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  T0 = cl_string_downcase(1, lex0[0]);
  T1 = (cl_env_copy->function=(ECL_SYM("COMPILE-FILE-PATHNAME",237)->symbol.gfdef))->cfun.entry(3, T0, ECL_SYM("TYPE",1353), VV[89]) /*  COMPILE-FILE-PATHNAME */;
  T2 = cl_merge_pathnames(2, VV[58], T1);
  value0 = cl_translate_logical_pathname(1, T2);
  return value0;
 }
}
/*      local function FIND-ARCHIVE                                   */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC3867find_archive(volatile cl_object *lex0, cl_object v1system)
{
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  value0 = LC3866existing_system_output(lex0, v1system, VV[89]);
  if ((value0)!=ECL_NIL) { goto L2; }
  value0 = LC3866existing_system_output(lex0, v1system, VV[63]);
  return value0;
L2:;
  cl_env_copy->nvalues = 1;
  return value0;
 }
}
/*      local function EXISTING-SYSTEM-OUTPUT                         */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC3866existing_system_output(volatile cl_object *lex0, cl_object v1system, cl_object v2type)
{
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3o;
   v3o = LC3865system_output(lex0, v1system, v2type);
   if (Null(v3o)) { goto L3; }
   v3o = cl_probe_file(v3o);
   if (Null(v3o)) { goto L3; }
   value0 = cl_namestring(v3o);
   return value0;
L3:;
   value0 = ECL_NIL;
   cl_env_copy->nvalues = 1;
   return value0;
  }
 }
}
/*      local function SYSTEM-OUTPUT                                  */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC3865system_output(volatile cl_object *lex0, cl_object v1system, cl_object v2type)
{
 cl_object T0;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3build;
   T0 = LC3863asdfsym(lex0, VV[87]);
   v3build = (cl_env_copy->function=(ECL_SYM("MAKE-INSTANCE",951)->symbol.gfdef))->cfun.entry(3, T0, ECL_SYM("TYPE",1353), v2type) /*  MAKE-INSTANCE */;
   T0 = LC3864asdfcall(3, lex0, VV[88], v3build, v1system);
   value0 = ecl_car(T0);
   cl_env_copy->nvalues = 1;
   return value0;
  }
 }
}
/*      local function ASDFCALL                                       */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC3864asdfcall(cl_narg narg, volatile cl_object *lex0, cl_object v1fun, ...)
{
 cl_object T0;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 if (ecl_unlikely(narg<1)) FEwrong_num_arguments_anonym();
 {
  cl_object v2rest;
  ecl_va_list args; ecl_va_start(args,v1fun,narg,1);
  v2rest = cl_grab_rest_args(args);
  ecl_va_end(args);
  T0 = LC3863asdfsym(lex0, v1fun);
  value0 = cl_apply(2, T0, v2rest);
  return value0;
 }
}
/*      local function ASDFSYM                                        */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC3863asdfsym(volatile cl_object *lex0, cl_object v1x)
{
 cl_object T0;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  T0 = cl_string(v1x);
  value0 = cl_find_symbol(2, T0, lex0[1]);
  return value0;
 }
}
/*      function definition for SHARED-CC                             */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3870shared_cc(cl_object v1o_pathname, cl_object v2object_files)
{
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4;
   v3 = ecl_function_dispatch(cl_env_copy,VV[151])(1, ecl_symbol_value(VV[92])) /*  SPLIT-PROGRAM-OPTIONS */;
   v4 = ecl_function_dispatch(cl_env_copy,VV[151])(1, ecl_symbol_value(VV[19])) /*  SPLIT-PROGRAM-OPTIONS */;
   value0 = L3851linker_cc(8, v1o_pathname, v2object_files, ECL_SYM("TYPE",1353), VV[82], VV[93], v3, VV[94], v4);
   return value0;
  }
 }
}
/*      function definition for BUNDLE-CC                             */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3871bundle_cc(cl_object v1o_pathname, cl_object v2init_name, cl_object v3object_files)
{
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v4;
   cl_object v5;
   v4 = ecl_function_dispatch(cl_env_copy,VV[151])(1, ecl_symbol_value(VV[96])) /*  SPLIT-PROGRAM-OPTIONS */;
   v5 = ecl_function_dispatch(cl_env_copy,VV[151])(1, ecl_symbol_value(VV[19])) /*  SPLIT-PROGRAM-OPTIONS */;
   value0 = L3851linker_cc(8, v1o_pathname, v3object_files, ECL_SYM("TYPE",1353), VV[74], VV[93], v4, VV[94], v5);
   return value0;
  }
 }
}
/*      function definition for COMPILER-PASS/GENERATE-CXX            */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3872compiler_pass_generate_cxx(cl_object volatile v1c_pathname, cl_object volatile v2h_pathname, cl_object volatile v3data_pathname, cl_object volatile v4init_name, cl_object volatile v5source)
{
 cl_object T0, T1, T2;
 cl_object volatile env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object volatile value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  ecl_bds_bind(cl_env_copy,VV[103],ecl_make_fixnum(0)); /*  *INLINE-BLOCKS* */
  ecl_bds_bind(cl_env_copy,VV[104],ecl_make_fixnum(0)); /*  *TEMP*    */
  ecl_bds_bind(cl_env_copy,VV[105],ecl_make_fixnum(0)); /*  *MAX-TEMP* */
  ecl_bds_bind(cl_env_copy,VV[106],ecl_make_fixnum(0)); /*  *NEXT-CFUN* */
  ecl_bds_bind(cl_env_copy,VV[107],ecl_make_fixnum(0)); /*  *LAST-LABEL* */
  cl_set(VV[108],VV[109]);
  T0 = cl_open(7, v1c_pathname, ECL_SYM("DIRECTION",1246), ECL_SYM("OUTPUT",1316), ECL_SYM("IF-DOES-NOT-EXIST",1274), ECL_SYM("CREATE",1241), ECL_SYM("IF-EXISTS",1276), ECL_SYM("SUPERSEDE",1348));
  ecl_bds_bind(cl_env_copy,VV[110],T0);           /*  *COMPILER-OUTPUT1* */
  {
   volatile bool unwinding = FALSE;
   cl_index v6=ECL_STACK_INDEX(cl_env_copy),v7;
   ecl_frame_ptr next_fr;
   ecl_frs_push(cl_env_copy,ECL_PROTECT_TAG);
   if (__ecl_frs_push_result) {
     unwinding = TRUE; next_fr=cl_env_copy->nlj_fr;
   } else {
   {
    struct ecl_stack_frame _ecl_inner_frame_aux;
    volatile cl_object _ecl_inner_frame = ecl_stack_frame_open(cl_env_copy,(cl_object)&_ecl_inner_frame_aux,0);
    {
     volatile cl_object v8;
     v8 = _ecl_inner_frame;
     T0 = cl_lisp_implementation_type();
     T1 = cl_lisp_implementation_version();
     ecl_function_dispatch(cl_env_copy,VV[175])(3, VV[111], T0, T1) /*  WT-COMMENT-NL */;
     {
      cl_object volatile v10;                     /*  MINUTE          */
      cl_object volatile v11;                     /*  HOUR            */
      cl_object volatile v12;                     /*  DAY             */
      cl_object volatile v13;                     /*  MONTH           */
      cl_object volatile v14;                     /*  YEAR            */
      value0 = cl_get_decoded_time();
      {
       v10 = cl_env_copy->values[1];
       v11 = cl_env_copy->values[2];
       v12 = cl_env_copy->values[3];
       v13 = cl_env_copy->values[4];
       v14 = cl_env_copy->values[5];
      }
      ecl_function_dispatch(cl_env_copy,VV[175])(6, VV[112], v14, v13, v12, v11, v10) /*  WT-COMMENT-NL */;
      T0 = cl_software_type();
      T1 = cl_software_version();
      T2 = cl_machine_type();
      ecl_function_dispatch(cl_env_copy,VV[175])(4, VV[113], T0, T1, T2) /*  WT-COMMENT-NL */;
     }
     ecl_function_dispatch(cl_env_copy,VV[175])(2, VV[114], v5source) /*  WT-COMMENT-NL */;
     T0 = cl_open(7, v2h_pathname, ECL_SYM("DIRECTION",1246), ECL_SYM("OUTPUT",1316), ECL_SYM("IF-DOES-NOT-EXIST",1274), ECL_SYM("CREATE",1241), ECL_SYM("IF-EXISTS",1276), ECL_SYM("SUPERSEDE",1348));
     ecl_bds_bind(cl_env_copy,VV[115],T0);        /*  *COMPILER-OUTPUT2* */
     {
      volatile bool unwinding = FALSE;
      cl_index v9=ECL_STACK_INDEX(cl_env_copy),v10;
      ecl_frame_ptr next_fr;
      ecl_frs_push(cl_env_copy,ECL_PROTECT_TAG);
      if (__ecl_frs_push_result) {
        unwinding = TRUE; next_fr=cl_env_copy->nlj_fr;
      } else {
      {
       struct ecl_stack_frame _ecl_inner_frame_aux;
       volatile cl_object _ecl_inner_frame = ecl_stack_frame_open(cl_env_copy,(cl_object)&_ecl_inner_frame_aux,0);
       {
        cl_object v11;
        v11 = _ecl_inner_frame;
        ecl_function_dispatch(cl_env_copy,VV[176])(2, VV[116], ecl_symbol_value(VV[117])) /*  WT-NL1 */;
        ecl_function_dispatch(cl_env_copy,VV[177])(3, v4init_name, v2h_pathname, v3data_pathname) /*  CTOP-WRITE */;
        ecl_terpri(ecl_symbol_value(VV[110]));
        cl_env_copy->values[0] = ecl_terpri(ecl_symbol_value(VV[115]));
        cl_env_copy->nvalues = 1;
        ecl_stack_frame_push_values(v11);
        value0 = ECL_NIL;
        cl_env_copy->nvalues = 0;
        if (Null(ecl_symbol_value(VV[115]))) { goto L22; }
        cl_close(1, ecl_symbol_value(VV[115]));
L22:;cl_env_copy->values[0]=ecl_stack_frame_pop_values(v11);
       }
       ecl_stack_frame_close(_ecl_inner_frame);
      }
        next_fr = NULL;
      }
      ecl_frs_pop(cl_env_copy);
      v10=ecl_stack_push_values(cl_env_copy);
      if (Null(ecl_symbol_value(VV[115]))) { goto L24; }
      cl_close(3, ecl_symbol_value(VV[115]), ECL_SYM("ABORT",1222), ECL_T);
L24:;
      ecl_stack_pop_values(cl_env_copy,v10);
      if (unwinding) ecl_unwind(cl_env_copy,next_fr);
      ECL_STACK_SET_INDEX(cl_env_copy,v9);
      ecl_bds_unwind1(cl_env_copy);
     }
     ecl_stack_frame_push_values(v8);
     value0 = ECL_NIL;
     cl_env_copy->nvalues = 0;
     if (Null(ecl_symbol_value(VV[110]))) { goto L26; }
     cl_close(1, ecl_symbol_value(VV[110]));
L26:;cl_env_copy->values[0]=ecl_stack_frame_pop_values(v8);
    }
    ecl_stack_frame_close(_ecl_inner_frame);
   }
     next_fr = NULL;
   }
   ecl_frs_pop(cl_env_copy);
   v7=ecl_stack_push_values(cl_env_copy);
   if (Null(ecl_symbol_value(VV[110]))) { goto L28; }
   cl_close(3, ecl_symbol_value(VV[110]), ECL_SYM("ABORT",1222), ECL_T);
L28:;
   ecl_stack_pop_values(cl_env_copy,v7);
   if (unwinding) ecl_unwind(cl_env_copy,next_fr);
   ECL_STACK_SET_INDEX(cl_env_copy,v6);
   ecl_bds_unwind1(cl_env_copy);
  }
  value0 = ecl_function_dispatch(cl_env_copy,VV[178])(1, v3data_pathname) /*  DATA-C-DUMP */;
  ecl_bds_unwind_n(cl_env_copy,5);
  return value0;
 }
}
/*      function definition for COMPILER-PASS/ASSEMBLE-CXX            */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3873compiler_pass_assemble_cxx(cl_narg narg, cl_object v1input_file, cl_object v2output_file, ...)
{
 cl_object T0, T1, T2, T3;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 if (ecl_unlikely(narg<2)) FEwrong_num_arguments_anonym();
 {
  cl_object v3c_file;
  cl_object v4h_file;
  cl_object v5data_file;
  cl_object v6system_p;
  ecl_va_list args; ecl_va_start(args,v2output_file,narg,2);
  {
   cl_object keyvars[8];
   cl_parse_key(args,4,L3873compiler_pass_assemble_cxxkeys,keyvars,NULL,TRUE);
   ecl_va_end(args);
   v3c_file = keyvars[0];
   v4h_file = keyvars[1];
   v5data_file = keyvars[2];
   v6system_p = keyvars[3];
  }
  {
   cl_object v7cpath;
   cl_object v8hpath;
   cl_object v9dpath;
   cl_object v10opath;
   cl_object v11to_delete;
   cl_object v12init_name;
   v7cpath = (cl_env_copy->function=(ECL_SYM("COMPILE-FILE-PATHNAME",237)->symbol.gfdef))->cfun.entry(5, v2output_file, VV[119], v3c_file, ECL_SYM("TYPE",1353), VV[71]) /*  COMPILE-FILE-PATHNAME */;
   v8hpath = (cl_env_copy->function=(ECL_SYM("COMPILE-FILE-PATHNAME",237)->symbol.gfdef))->cfun.entry(5, v2output_file, VV[119], v4h_file, ECL_SYM("TYPE",1353), VV[120]) /*  COMPILE-FILE-PATHNAME */;
   v9dpath = (cl_env_copy->function=(ECL_SYM("COMPILE-FILE-PATHNAME",237)->symbol.gfdef))->cfun.entry(5, v2output_file, VV[119], v5data_file, ECL_SYM("TYPE",1353), VV[121]) /*  COMPILE-FILE-PATHNAME */;
   v10opath = (cl_env_copy->function=(ECL_SYM("COMPILE-FILE-PATHNAME",237)->symbol.gfdef))->cfun.entry(3, v2output_file, ECL_SYM("TYPE",1353), ECL_SYM("OBJECT",1312)) /*  COMPILE-FILE-PATHNAME */;
   if ((v3c_file)!=ECL_NIL) { goto L7; }
   T0 = ecl_list1(v7cpath);
   goto L6;
L7:;
   T0 = ECL_NIL;
L6:;
   if ((v4h_file)!=ECL_NIL) { goto L10; }
   T1 = ecl_list1(v8hpath);
   goto L9;
L10:;
   T1 = ECL_NIL;
L9:;
   if ((v5data_file)!=ECL_NIL) { goto L13; }
   T2 = ecl_list1(v9dpath);
   goto L12;
L13:;
   T2 = ECL_NIL;
L12:;
   if ((v6system_p)!=ECL_NIL) { goto L16; }
   T3 = ecl_list1(v10opath);
   goto L15;
L16:;
   T3 = ECL_NIL;
L15:;
   v11to_delete = cl_nconc(4, T0, T1, T2, T3);
   if (Null(v6system_p)) { goto L20; }
   T0 = ECL_SYM("OBJECT",1312);
   goto L19;
L20:;
   T0 = VV[74];
L19:;
   v12init_name = ecl_function_dispatch(cl_env_copy,VV[184])(3, v2output_file, VV[122], T0) /*  COMPUTE-INIT-NAME */;
   L3872compiler_pass_generate_cxx(v7cpath, v8hpath, v9dpath, v12init_name, v1input_file);
   if (Null(v6system_p)) { goto L24; }
   L3854compiler_cc(v7cpath, v10opath);
   goto L23;
L24:;
   L3854compiler_cc(v7cpath, v10opath);
   T0 = ecl_function_dispatch(cl_env_copy,VV[157])(1, v2output_file) /*  BRIEF-NAMESTRING */;
   T1 = ecl_function_dispatch(cl_env_copy,VV[157])(1, v10opath) /*  BRIEF-NAMESTRING */;
   T2 = ecl_list1(T1);
   L3871bundle_cc(T0, v12init_name, T2);
L23:;
   {
    cl_object v13;
    cl_object v14;
    v13 = ECL_NIL;
    {
     cl_object v15;
     v15 = v11to_delete;
     if (ecl_unlikely(!ECL_LISTP(v15))) FEtype_error_list(v15);
     value0 = ECL_NIL;
     cl_env_copy->nvalues = 0;
     v14 = v15;
    }
L31:;
    if (!(ecl_endp(v14))) { goto L33; }
    goto L32;
L33:;
    v13 = ECL_CONS_CAR(v14);
    {
     cl_object v15;
     v15 = ECL_CONS_CDR(v14);
     if (ecl_unlikely(!ECL_LISTP(v15))) FEtype_error_list(v15);
     value0 = ECL_NIL;
     cl_env_copy->nvalues = 0;
     v14 = v15;
    }
    ecl_function_dispatch(cl_env_copy,VV[9])(1, v13);
    goto L31;
L32:;
    value0 = v11to_delete;
    cl_env_copy->nvalues = 1;
    return value0;
   }
  }
 }
}
/*      function definition for BUILDER                               */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3874builder(volatile cl_narg narg, cl_object volatile v1target, cl_object volatile v2output_name, ...)
{
 cl_object T0, T1, T2;
 cl_object volatile env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object volatile value0;
 ecl_cs_check(cl_env_copy,value0);
 if (ecl_unlikely(narg<2)) FEwrong_num_arguments_anonym();
 {
  cl_object volatile v3lisp_files;
  cl_object volatile v4ld_flags;
  cl_object volatile v5ld_libs;
  cl_object volatile v6init_name;
  cl_object volatile v7main_name;
  cl_object volatile v8prologue_code;
  cl_object volatile v9epilogue_code;
  ecl_va_list args; ecl_va_start(args,v2output_name,narg,2);
  {
   cl_object keyvars[14];
   cl_parse_key(args,7,L3874builderkeys,keyvars,NULL,FALSE);
   ecl_va_end(args);
   v3lisp_files = keyvars[0];
   v4ld_flags = keyvars[1];
   v5ld_libs = keyvars[2];
   v6init_name = keyvars[3];
   v7main_name = keyvars[4];
   if (Null(keyvars[12])) {
    v8prologue_code = VV[1];
   } else {
    v8prologue_code = keyvars[5];
   }
   if (Null(keyvars[13])) {
    if (!((v1target)==(VV[16]))) { goto L3; }
    v9epilogue_code = VV[124];
    goto L2;
L3:;
    v9epilogue_code = ECL_NIL;
L2:;
   } else {
    v9epilogue_code = keyvars[6];
   }
  }
  {
   volatile cl_object v10target;
   volatile cl_object v11output_name;
   volatile cl_object v12wrap_name;
   value0 = ecl_symbol_value(VV[125]);
   if ((value0)!=ECL_NIL) { goto L7; }
   T0 = Null(ecl_symbol_value(ECL_SYM("*COMPILE-VERBOSE*",31)))?ECL_T:ECL_NIL;
   goto L5;
L7:;
   T0 = value0;
   goto L5;
L5:;
   ecl_bds_bind(cl_env_copy,VV[125],T0);          /*  *SUPPRESS-COMPILER-MESSAGES* */
   v10target = ecl_function_dispatch(cl_env_copy,VV[193])(1, v1target) /*  NORMALIZE-BUILD-TARGET-NAME */;
   if (ECL_SYMBOLP(v2output_name)) { goto L13; }
   if (!(ECL_STRINGP(v2output_name))) { goto L11; }
   goto L12;
L13:;
L12:;
   v11output_name = (cl_env_copy->function=(ECL_SYM("COMPILE-FILE-PATHNAME",237)->symbol.gfdef))->cfun.entry(3, v2output_name, ECL_SYM("TYPE",1353), v10target) /*  COMPILE-FILE-PATHNAME */;
   goto L10;
L11:;
   v11output_name = v2output_name;
L10:;
   v12wrap_name = v6init_name;
   v6init_name = ecl_function_dispatch(cl_env_copy,VV[184])(3, v11output_name, VV[122], v10target) /*  COMPUTE-INIT-NAME */;
   if (v12wrap_name==ECL_NIL) { goto L18; }
   if (!(ecl_equal(v6init_name,v12wrap_name))) { goto L20; }
   ecl_function_dispatch(cl_env_copy,VV[152])(1, VV[126]) /*  CMPWARN */;
   v12wrap_name = ECL_NIL;
   goto L18;
L20:;
   if (!((v10target)==(VV[78]))) { goto L30; }
   value0 = VV[127];
   goto L28;
L30:;
   value0 = ECL_NIL;
   goto L28;
L28:;
   if ((value0)!=ECL_NIL) { goto L27; }
   if (!((v10target)==(VV[63]))) { goto L33; }
   T0 = VV[128];
   goto L25;
L33:;
   T0 = ECL_NIL;
   goto L25;
L27:;
   T0 = value0;
   goto L25;
L25:;
   if (!(T0==ECL_NIL)) { goto L18; }
   ecl_function_dispatch(cl_env_copy,VV[152])(1, VV[129]) /*  CMPWARN */;
L18:;
   if ((v7main_name)!=ECL_NIL) { goto L35; }
   v7main_name = ecl_function_dispatch(cl_env_copy,VV[184])(5, v11output_name, VV[122], v10target, VV[130], VV[131]) /*  COMPUTE-INIT-NAME */;
L35:;
   if (!(v9epilogue_code==ECL_NIL)) { goto L39; }
   v9epilogue_code = VV[1];
   goto L38;
L39:;
   if (ECL_STRINGP(v9epilogue_code)) { goto L38; }
   {
    volatile cl_object v13;
    v13 = ecl_symbol_value(ECL_SYM("+IO-SYNTAX-PROGV-LIST+",1798));
    {
     cl_object v15, v16; cl_index v14;
     v15 = ECL_CONS_CAR(v13);
     v16 = ECL_CONS_CDR(v13);
     v14 = ecl_progv(cl_env_copy, v15, v16);
     {
      volatile cl_object v17stream;
      v17stream = cl_make_string_output_stream(0);
      {
       volatile bool unwinding = FALSE;
       cl_index v18=ECL_STACK_INDEX(cl_env_copy),v19;
       ecl_frame_ptr next_fr;
       ecl_frs_push(cl_env_copy,ECL_PROTECT_TAG);
       if (__ecl_frs_push_result) {
         unwinding = TRUE; next_fr=cl_env_copy->nlj_fr;
       } else {
       ecl_princ(VV[132],v17stream);
       T0 = cl_write_to_string(1, v9epilogue_code);
       ecl_function_dispatch(cl_env_copy,VV[194])(2, T0, v17stream) /*  WT-FILTERED-DATA */;
       ecl_princ(VV[133],v17stream);
       cl_env_copy->values[0] = cl_get_output_stream_string(v17stream);
         next_fr = NULL;
       }
       ecl_frs_pop(cl_env_copy);
       v19=ecl_stack_push_values(cl_env_copy);
       cl_close(1, v17stream);
       ecl_stack_pop_values(cl_env_copy,v19);
       if (unwinding) ecl_unwind(cl_env_copy,next_fr);
       v9epilogue_code = cl_env_copy->values[0];
       ECL_STACK_SET_INDEX(cl_env_copy,v18);
      }
     }
     ecl_bds_unwind(cl_env_copy,v14);
    }
   }
L38:;
   if (!(v8prologue_code==ECL_NIL)) { goto L54; }
   v8prologue_code = VV[1];
   goto L53;
L54:;
   {
    volatile cl_object v13;
    v13 = ecl_make_bool(ECL_STRINGP(v8prologue_code));
    if (Null(v13)) { goto L58; }
    goto L53;
L58:;
    {
     volatile cl_object v14;
     v14 = ecl_symbol_value(ECL_SYM("+IO-SYNTAX-PROGV-LIST+",1798));
     {
      cl_object v16, v17; cl_index v15;
      v16 = ECL_CONS_CAR(v14);
      v17 = ECL_CONS_CDR(v14);
      v15 = ecl_progv(cl_env_copy, v16, v17);
      {
       volatile cl_object v18stream;
       v18stream = cl_make_string_output_stream(0);
       {
        volatile bool unwinding = FALSE;
        cl_index v19=ECL_STACK_INDEX(cl_env_copy),v20;
        ecl_frame_ptr next_fr;
        ecl_frs_push(cl_env_copy,ECL_PROTECT_TAG);
        if (__ecl_frs_push_result) {
          unwinding = TRUE; next_fr=cl_env_copy->nlj_fr;
        } else {
        ecl_princ(VV[132],v18stream);
        T0 = cl_write_to_string(1, v8prologue_code);
        ecl_function_dispatch(cl_env_copy,VV[194])(2, T0, v18stream) /*  WT-FILTERED-DATA */;
        ecl_princ(VV[133],v18stream);
        cl_env_copy->values[0] = cl_get_output_stream_string(v18stream);
          next_fr = NULL;
        }
        ecl_frs_pop(cl_env_copy);
        v20=ecl_stack_push_values(cl_env_copy);
        cl_close(1, v18stream);
        ecl_stack_pop_values(cl_env_copy,v20);
        if (unwinding) ecl_unwind(cl_env_copy,next_fr);
        v8prologue_code = cl_env_copy->values[0];
        ECL_STACK_SET_INDEX(cl_env_copy,v19);
       }
      }
      ecl_bds_unwind(cl_env_copy,v15);
     }
    }
   }
L53:;
   {
    cl_object v13tmp_names;
    cl_object v14tmp_name;
    cl_object v15c_name;
    cl_object v16o_name;
    cl_object v17submodules;
    cl_object v18c_file;
    v13tmp_names = L3846safe_mkstemp(VV[134]);
    v14tmp_name = ecl_car(v13tmp_names);
    T0 = (cl_env_copy->function=(ECL_SYM("COMPILE-FILE-PATHNAME",237)->symbol.gfdef))->cfun.entry(3, v14tmp_name, ECL_SYM("TYPE",1353), VV[71]) /*  COMPILE-FILE-PATHNAME */;
    v15c_name = ecl_function_dispatch(cl_env_copy,VV[157])(1, T0) /*  BRIEF-NAMESTRING */;
    T0 = (cl_env_copy->function=(ECL_SYM("COMPILE-FILE-PATHNAME",237)->symbol.gfdef))->cfun.entry(3, v14tmp_name, ECL_SYM("TYPE",1353), ECL_SYM("OBJECT",1312)) /*  COMPILE-FILE-PATHNAME */;
    v16o_name = ecl_function_dispatch(cl_env_copy,VV[157])(1, T0) /*  BRIEF-NAMESTRING */;
    v17submodules = ECL_NIL;
    v18c_file = ECL_NIL;
    {
     cl_object v19;
     v19 = cl_reverse(v3lisp_files);
     goto L80;
L79:;
     {
      cl_object v20item;
      v20item = ecl_car(v19);
      {
       cl_object v21path;
       cl_object v22kind;
       if (!(ECL_SYMBOLP(v20item))) { goto L86; }
       v21path = L3869system_ld_flag(v20item);
       goto L85;
L86:;
       if (Null(cl_pathnamep(v20item))) { goto L88; }
       v21path = v20item;
       goto L85;
L88:;
       if (!(ECL_STRINGP(v20item))) { goto L90; }
       v21path = cl_parse_namestring(1, v20item);
       goto L85;
L90:;
       v21path = si_etypecase_error(v20item, VV[135]);
L85:;
       v22kind = L3861guess_kind(v21path);
       {
        cl_object v23;
        cl_object v24;
        cl_object v25;
        if (ecl_eql(v10target,VV[78])) { goto L97; }
        T0 = VV[136];
        goto L96;
L97:;
        T0 = ECL_NIL;
L96:;
        v23 = ecl_append(T0,VV[70]);
        v24 = v22kind;
        v25 = v23;
        if ((ecl_memql(v24,v25))!=ECL_NIL) { goto L93; }
       }
       cl_error(4, VV[137], v20item, v22kind, v10target);
L93:;
       {
        cl_object v23;
        cl_object v24;
        v23 = ecl_function_dispatch(cl_env_copy,VV[195])(2, v21path, v22kind) /*  GUESS-INIT-NAME */;
        v24 = L3862guess_ld_libs(1, v21path);
        if (Null(v24)) { goto L103; }
        v5ld_libs = CONS(v24,v5ld_libs);
L103:;
        if (Null(v23)) { goto L84; }
        T0 = cl_list(2, v23, v21path);
        v17submodules = CONS(T0,v17submodules);
       }
      }
L84:;
     }
     v19 = ecl_cdr(v19);
L80:;
     if (Null(v19)) { goto L110; }
     goto L79;
L110:;
    }
    v18c_file = cl_open(5, v15c_name, ECL_SYM("DIRECTION",1246), ECL_SYM("OUTPUT",1316), ECL_SYM("EXTERNAL-FORMAT",1264), ECL_SYM("DEFAULT",1243));
    cl_format(3, v18c_file, ecl_symbol_value(VV[98]), v17submodules);
    {
     cl_object v19init_tag;
     v19init_tag = ecl_function_dispatch(cl_env_copy,VV[196])(3, v6init_name, VV[122], v10target) /*  INIT-NAME-TAG */;
     if (!((v10target)==(VV[16]))) { goto L117; }
     cl_format(7, v18c_file, ecl_symbol_value(VV[99]), v6init_name, v19init_tag, VV[1], v17submodules, VV[1]);
     cl_format(5, v18c_file, ecl_symbol_value(VV[101]), v8prologue_code, v6init_name, v9epilogue_code);
     cl_close(1, v18c_file);
     L3854compiler_cc(v15c_name, v16o_name);
     T0 = cl_namestring(v16o_name);
     T1 = ecl_list1(T0);
     T2 = cl_append(3, v4ld_flags, T1, v5ld_libs);
     L3851linker_cc(2, v11output_name, T2);
     goto L116;
L117:;
     if (!((v10target)==(VV[78]))) { goto L123; }
     cl_format(7, v18c_file, ecl_symbol_value(VV[99]), v6init_name, v19init_tag, v8prologue_code, v17submodules, v9epilogue_code);
     if (Null(v12wrap_name)) { goto L126; }
     cl_format(4, v18c_file, ecl_symbol_value(VV[100]), v12wrap_name, v6init_name);
L126:;
     cl_format(6, v18c_file, ecl_symbol_value(VV[102]), v7main_name, v8prologue_code, v6init_name, v9epilogue_code);
     cl_close(1, v18c_file);
     L3854compiler_cc(v15c_name, v16o_name);
     if (Null(cl_probe_file(v11output_name))) { goto L131; }
     cl_delete_file(v11output_name);
L131:;
     L3852linker_ar(v11output_name, v16o_name, v5ld_libs);
     goto L116;
L123:;
     if (!((v10target)==(VV[63]))) { goto L133; }
     cl_format(7, v18c_file, ecl_symbol_value(VV[99]), v6init_name, v19init_tag, v8prologue_code, v17submodules, v9epilogue_code);
     if (Null(v12wrap_name)) { goto L136; }
     cl_format(4, v18c_file, ecl_symbol_value(VV[100]), v12wrap_name, v6init_name);
L136:;
     cl_format(6, v18c_file, ecl_symbol_value(VV[102]), v7main_name, v8prologue_code, v6init_name, v9epilogue_code);
     cl_close(1, v18c_file);
     L3854compiler_cc(v15c_name, v16o_name);
     T0 = ecl_list1(v16o_name);
     T1 = cl_append(3, v4ld_flags, T0, v5ld_libs);
     L3870shared_cc(v11output_name, T1);
     goto L116;
L133:;
     if (!((v10target)==(VV[74]))) { goto L141; }
     cl_format(7, v18c_file, ecl_symbol_value(VV[99]), v6init_name, v19init_tag, v8prologue_code, v17submodules, v9epilogue_code);
     cl_close(1, v18c_file);
     L3854compiler_cc(v15c_name, v16o_name);
     T0 = ecl_list1(v16o_name);
     T1 = cl_append(3, v4ld_flags, T0, v5ld_libs);
     L3871bundle_cc(v11output_name, v6init_name, T1);
     goto L116;
L141:;
     si_ecase_error(v10target, VV[138]);
L116:;
     {
      cl_object v20;
      cl_object v21;
      v20 = ECL_NIL;
      {
       cl_object v22;
       v22 = v13tmp_names;
       if (ecl_unlikely(!ECL_LISTP(v22))) FEtype_error_list(v22);
       value0 = ECL_NIL;
       cl_env_copy->nvalues = 0;
       v21 = v22;
      }
L151:;
      if (!(ecl_endp(v21))) { goto L153; }
      goto L152;
L153:;
      v20 = ECL_CONS_CAR(v21);
      {
       cl_object v22;
       v22 = ECL_CONS_CDR(v21);
       if (ecl_unlikely(!ECL_LISTP(v22))) FEtype_error_list(v22);
       value0 = ECL_NIL;
       cl_env_copy->nvalues = 0;
       v21 = v22;
      }
      ecl_function_dispatch(cl_env_copy,VV[9])(1, v20);
      goto L151;
L152:;
      goto L146;
     }
L146:;
     L3847cmp_delete_file(v15c_name);
     L3847cmp_delete_file(v16o_name);
     value0 = v11output_name;
     cl_env_copy->nvalues = 1;
     ecl_bds_unwind1(cl_env_copy);
     return value0;
    }
   }
  }
 }
}
/*      function definition for BUILD-FASL                            */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3875build_fasl(cl_narg narg, ...)
{
 cl_object T0;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
  cl_object v1args;
  ecl_va_list args; ecl_va_start(args,narg,narg,0);
  v1args = cl_grab_rest_args(args);
  ecl_va_end(args);
  T0 = ecl_fdefinition(VV[139]);
  value0 = cl_apply(3, T0, VV[74], v1args);
  return value0;
 }
}
/*      function definition for BUILD-PROGRAM                         */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3876build_program(cl_narg narg, ...)
{
 cl_object T0;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
  cl_object v1args;
  ecl_va_list args; ecl_va_start(args,narg,narg,0);
  v1args = cl_grab_rest_args(args);
  ecl_va_end(args);
  T0 = ecl_fdefinition(VV[139]);
  value0 = cl_apply(3, T0, VV[16], v1args);
  return value0;
 }
}
/*      function definition for BUILD-STATIC-LIBRARY                  */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3877build_static_library(cl_narg narg, ...)
{
 cl_object T0;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
  cl_object v1args;
  ecl_va_list args; ecl_va_start(args,narg,narg,0);
  v1args = cl_grab_rest_args(args);
  ecl_va_end(args);
  T0 = ecl_fdefinition(VV[139]);
  value0 = cl_apply(3, T0, VV[78], v1args);
  return value0;
 }
}
/*      function definition for BUILD-SHARED-LIBRARY                  */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3878build_shared_library(cl_narg narg, ...)
{
 cl_object T0;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
  cl_object v1args;
  ecl_va_list args; ecl_va_start(args,narg,narg,0);
  v1args = cl_grab_rest_args(args);
  ecl_va_end(args);
  T0 = ecl_fdefinition(VV[139]);
  value0 = cl_apply(3, T0, VV[63], v1args);
  return value0;
 }
}

#include "cmp/cmpbackend-cxx.data"
#ifdef __cplusplus
extern "C"
#endif
ECL_DLLEXPORT void _eclhYomhh32vmkk9_9gl7vD71(cl_object flag)
{
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 cl_object *VVtemp;
 if (flag != OBJNULL){
 Cblock = flag;
 #ifndef ECL_DYNAMIC_VV
 flag->cblock.data = VV;
 #endif
 flag->cblock.data_size = VM;
 flag->cblock.temp_data_size = VMtemp;
 flag->cblock.data_text = compiler_data_text;
 flag->cblock.cfuns_size = compiler_cfuns_size;
 flag->cblock.cfuns = compiler_cfuns;
 flag->cblock.source = ecl_make_constant_base_string("SRC:CMP;CMPBACKEND-CXX;CMPBACKEND-CXX.LSP.NEWEST",-1);
 return;}
 #ifdef ECL_DYNAMIC_VV
 VV = Cblock->cblock.data;
 #endif
 Cblock->cblock.data_text = (const cl_object *)"@EcLtAg:_eclhYomhh32vmkk9_9gl7vD71@";
 VVtemp = Cblock->cblock.temp_data;
 ECL_DEFINE_SETF_FUNCTIONS
  si_select_package(VVtemp[0]);
  ecl_cmp_defun(VV[144]);                         /*  SAFE-MKSTEMP    */
  ecl_cmp_defun(VV[145]);                         /*  CMP-DELETE-FILE */
 {
  cl_object T0;
  cl_object volatile env0 = ECL_NIL;
  {
   cl_object volatile v1;
   v1 = ecl_make_cfun((cl_objectfn_fixed)LC3848__lambda7,ECL_NIL,Cblock,0);
   T0 = v1;
  }
  cl_set(ECL_SYM("*EXIT-HOOKS*",1543),CONS(T0,ecl_symbol_value(ECL_SYM("*EXIT-HOOKS*",1543))));
 }
  ecl_cmp_defmacro(VV[147]);                      /*  FIX-FOR-MINGW   */
  ecl_cmp_defun(VV[150]);                         /*  GET-DEPRECATED-USER-LD-FLAGS */
  ecl_cmp_defun(VV[153]);                         /*  LINKER-CC       */
  ecl_cmp_defun(VV[159]);                         /*  LINKER-AR       */
  ecl_cmp_defun(VV[160]);                         /*  STATIC-LIB-AR   */
  ecl_cmp_defun(VV[161]);                         /*  COMPILER-CC     */
  ecl_cmp_defun(VV[163]);                         /*  NEED-TO-DUMP-PRECOMPILED-HEADER */
  ecl_cmp_defun(VV[164]);                         /*  PRECOMPILED-HEADER-FLAGS */
  ecl_cmp_defun(VV[166]);                         /*  DUMP-PRECOMPILED-HEADER */
  ecl_cmp_defun(VV[167]);                         /*  ECL-INCLUDE-DIRECTORY */
  ecl_cmp_defun(VV[168]);                         /*  ECL-LIBRARY-DIRECTORY */
  ecl_cmp_defun(VV[169]);                         /*  GUESS-KIND      */
  ecl_cmp_defun(VV[170]);                         /*  GUESS-LD-LIBS   */
  ecl_cmp_defun(VV[171]);                         /*  SYSTEM-LD-FLAG  */
  ecl_cmp_defun(VV[172]);                         /*  SHARED-CC       */
  ecl_cmp_defun(VV[173]);                         /*  BUNDLE-CC       */
  si_Xmake_constant(VV[98], VVtemp[1]);
  si_Xmake_constant(VV[99], VVtemp[2]);
  si_Xmake_constant(VV[100], VVtemp[3]);
  si_Xmake_constant(VV[101], VVtemp[4]);
  si_Xmake_constant(VV[102], VVtemp[5]);
  ecl_cmp_defun(VV[174]);                         /*  COMPILER-PASS/GENERATE-CXX */
  ecl_cmp_defun(VV[179]);                         /*  COMPILER-PASS/ASSEMBLE-CXX */
  ecl_cmp_defun(VV[185]);                         /*  BUILDER         */
  ecl_cmp_defun(VV[197]);                         /*  BUILD-FASL      */
  ecl_cmp_defun(VV[198]);                         /*  BUILD-PROGRAM   */
  ecl_cmp_defun(VV[199]);                         /*  BUILD-STATIC-LIBRARY */
  ecl_cmp_defun(VV[200]);                         /*  BUILD-SHARED-LIBRARY */
}
