/*      Compiler: ECL 24.5.10                                         */
/*      Source: /builddir/build/BUILD/ecl-24.5.10-build/ecl-24.5.10/src/cmp/cmpenv-var.lsp */
#include <ecl/ecl-cmp.h>
#include "cmp/cmpenv-var.eclh"
/*      function definition for DECLARE-SPECIAL                       */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3207declare_special(cl_narg narg, cl_object v1name, ...)
{
 cl_object T0;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 if (ecl_unlikely(narg<1)) FEwrong_num_arguments_anonym();
 if (ecl_unlikely(narg>2)) FEwrong_num_arguments_anonym();
 {
  cl_object v2env;
  va_list args; va_start(args,v1name);
  {
   int i = 1;
   if (i >= narg) {
    v2env = ecl_symbol_value(VV[0]);
   } else {
    i++;
    v2env = va_arg(args,cl_object);
   }
  }
  va_end(args);
  if (Null(ecl_function_dispatch(cl_env_copy,VV[18])(2, v1name, v2env) /*  CMP-ENV-SEARCH-SYMBOL-MACRO */)) { goto L2; }
  ecl_function_dispatch(cl_env_copy,VV[19])(2, VV[1], v1name) /*  CMPERR */;
L2:;
  T0 = ecl_function_dispatch(cl_env_copy,VV[20])(5, v1name, VV[2], ECL_NIL, VV[3], ECL_SYM("SPECIAL",791)) /*  MAKE-GLOBAL-VAR */;
  value0 = ecl_function_dispatch(cl_env_copy,VV[21])(3, T0, v2env, ECL_NIL) /*  CMP-ENV-REGISTER-VAR */;
  return value0;
 }
}
/*      function definition for CHECK-GLOBAL                          */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3208check_global(cl_object v1name)
{
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v2;
   cl_object v3;
   cl_object v4;
   v2 = ecl_symbol_value(VV[5]);
   v3 = v1name;
   v4 = v2;
   value0 = ecl_memql(v3,v4);
   cl_env_copy->nvalues = 1;
   return value0;
  }
 }
}
/*      function definition for REGISTER-GLOBAL                       */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3209si__register_global(cl_object v1name)
{
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  cl_set(VV[5],cl_adjoin(2, v1name, ecl_symbol_value(VV[5])));
  value0 = ECL_NIL;
  cl_env_copy->nvalues = 0;
  return value0;
 }
}
/*      function definition for SPECIAL-VARIABLE-P                    */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3210special_variable_p(cl_object v1name)
{
 cl_object T0;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  value0 = si_specialp(v1name);
  if ((value0)!=ECL_NIL) { goto L2; }
  value0 = L3208check_global(v1name);
  if ((value0)!=ECL_NIL) { goto L2; }
  {
   cl_object v2v;
   v2v = ecl_function_dispatch(cl_env_copy,VV[25])(2, v1name, ecl_symbol_value(VV[8])) /*  CMP-ENV-SEARCH-VAR */;
   if (Null(v2v)) { goto L7; }
   T0 = ecl_function_dispatch(cl_env_copy,VV[26])(1, v2v) /*  VAR-KIND */;
   value0 = ecl_make_bool((T0)==(ECL_SYM("SPECIAL",791)));
   cl_env_copy->nvalues = 1;
   return value0;
L7:;
   value0 = ECL_NIL;
   cl_env_copy->nvalues = 1;
   return value0;
  }
L2:;
  cl_env_copy->nvalues = 1;
  return value0;
 }
}
/*      function definition for CONSTANT-VARIABLE-P                   */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3211constant_variable_p(cl_object v1name)
{
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  value0 = si_constp(v1name);
  return value0;
 }
}
/*      function definition for LOCAL-VARIABLE-P                      */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3212local_variable_p(cl_narg narg, cl_object v1name, ...)
{
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 if (ecl_unlikely(narg<1)) FEwrong_num_arguments_anonym();
 if (ecl_unlikely(narg>2)) FEwrong_num_arguments_anonym();
 {
  cl_object v2env;
  va_list args; va_start(args,v1name);
  {
   int i = 1;
   if (i >= narg) {
    v2env = ecl_symbol_value(VV[0]);
   } else {
    i++;
    v2env = va_arg(args,cl_object);
   }
  }
  va_end(args);
  {
   cl_object v3record;
   v3record = ecl_function_dispatch(cl_env_copy,VV[25])(2, v1name, v2env) /*  CMP-ENV-SEARCH-VAR */;
   if (Null(v3record)) { goto L4; }
   value0 = ecl_function_dispatch(cl_env_copy,VV[29])(1, v3record) /*  VAR-P */;
   return value0;
L4:;
   value0 = ECL_NIL;
   cl_env_copy->nvalues = 1;
   return value0;
  }
 }
}
/*      function definition for SYMBOL-MACRO-P                        */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3213symbol_macro_p(cl_narg narg, cl_object v1name, ...)
{
 cl_object T0;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 if (ecl_unlikely(narg<1)) FEwrong_num_arguments_anonym();
 if (ecl_unlikely(narg>2)) FEwrong_num_arguments_anonym();
 {
  cl_object v2env;
  va_list args; va_start(args,v1name);
  {
   int i = 1;
   if (i >= narg) {
    v2env = ecl_symbol_value(VV[0]);
   } else {
    i++;
    v2env = va_arg(args,cl_object);
   }
  }
  va_end(args);
  {
   cl_object v3record;
   v3record = ecl_function_dispatch(cl_env_copy,VV[25])(2, v1name, v2env) /*  CMP-ENV-SEARCH-VAR */;
   if (Null(v3record)) { goto L4; }
   T0 = ecl_function_dispatch(cl_env_copy,VV[29])(1, v3record) /*  VAR-P */;
   value0 = Null(T0)?ECL_T:ECL_NIL;
   cl_env_copy->nvalues = 1;
   return value0;
L4:;
   value0 = ECL_NIL;
   cl_env_copy->nvalues = 1;
   return value0;
  }
 }
}
/*      function definition for READ-ONLY-VARIABLE-P                  */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3214read_only_variable_p(cl_object v1name, cl_object v2other_decls)
{
 cl_object T0;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   v3 = v2other_decls;
   goto L4;
L3:;
   {
    cl_object v4i;
    v4i = ecl_car(v3);
    T0 = ecl_car(v4i);
    if (!((T0)==(VV[13]))) { goto L8; }
    {
     cl_object v5;
     cl_object v6;
     cl_object v7;
     v5 = ecl_cdr(v4i);
     v6 = v1name;
     v7 = v5;
     if (Null(ecl_memql(v6,v7))) { goto L8; }
    }
    value0 = ECL_T;
    cl_env_copy->nvalues = 1;
    return value0;
L8:;
   }
   v3 = ecl_cdr(v3);
L4:;
   if (Null(v3)) { goto L16; }
   goto L3;
L16:;
   value0 = ECL_NIL;
   cl_env_copy->nvalues = 1;
   return value0;
  }
 }
}
/*      function definition for VARIABLE-TYPE-IN-ENV                  */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3215variable_type_in_env(cl_narg narg, cl_object v1name, ...)
{
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 if (ecl_unlikely(narg<1)) FEwrong_num_arguments_anonym();
 if (ecl_unlikely(narg>2)) FEwrong_num_arguments_anonym();
 {
  cl_object v2env;
  va_list args; va_start(args,v1name);
  {
   int i = 1;
   if (i >= narg) {
    v2env = ecl_symbol_value(VV[0]);
   } else {
    i++;
    v2env = va_arg(args,cl_object);
   }
  }
  va_end(args);
  {
   cl_object v3var;
   v3var = ecl_function_dispatch(cl_env_copy,VV[25])(2, v1name, v2env) /*  CMP-ENV-SEARCH-VAR */;
   if (Null(ecl_function_dispatch(cl_env_copy,VV[29])(1, v3var) /*  VAR-P */)) { goto L3; }
   value0 = ecl_function_dispatch(cl_env_copy,VV[33])(1, v3var) /*  VAR-TYPE */;
   return value0;
L3:;
   {
    cl_object v4;
    v4 = si_get_sysprop(v1name, VV[15]);
    if (Null(v4)) { goto L6; }
    value0 = v4;
    cl_env_copy->nvalues = 1;
    return value0;
L6:;
    value0 = ECL_T;
    cl_env_copy->nvalues = 1;
    return value0;
   }
  }
 }
}

#include "cmp/cmpenv-var.data"
#ifdef __cplusplus
extern "C"
#endif
ECL_DLLEXPORT void _ecl2kkk1ZBlDoYj9_zOe7vD71(cl_object flag)
{
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 cl_object *VVtemp;
 if (flag != OBJNULL){
 Cblock = flag;
 #ifndef ECL_DYNAMIC_VV
 flag->cblock.data = VV;
 #endif
 flag->cblock.data_size = VM;
 flag->cblock.temp_data_size = VMtemp;
 flag->cblock.data_text = compiler_data_text;
 flag->cblock.cfuns_size = compiler_cfuns_size;
 flag->cblock.cfuns = compiler_cfuns;
 flag->cblock.source = ecl_make_constant_base_string("SRC:CMP;CMPENV-VAR.LSP.NEWEST",-1);
 return;}
 #ifdef ECL_DYNAMIC_VV
 VV = Cblock->cblock.data;
 #endif
 Cblock->cblock.data_text = (const cl_object *)"@EcLtAg:_ecl2kkk1ZBlDoYj9_zOe7vD71@";
 VVtemp = Cblock->cblock.temp_data;
 ECL_DEFINE_SETF_FUNCTIONS
  si_select_package(_ecl_static_0);
  ecl_cmp_defun(VV[17]);                          /*  DECLARE-SPECIAL */
  ecl_cmp_defun(VV[22]);                          /*  CHECK-GLOBAL    */
  ecl_cmp_defun(VV[23]);                          /*  REGISTER-GLOBAL */
  ecl_cmp_defun(VV[24]);                          /*  SPECIAL-VARIABLE-P */
  ecl_cmp_defun(VV[27]);                          /*  CONSTANT-VARIABLE-P */
  ecl_cmp_defun(VV[28]);                          /*  LOCAL-VARIABLE-P */
  ecl_cmp_defun(VV[30]);                          /*  SYMBOL-MACRO-P  */
  ecl_cmp_defun(VV[31]);                          /*  READ-ONLY-VARIABLE-P */
  ecl_cmp_defun(VV[32]);                          /*  VARIABLE-TYPE-IN-ENV */
}
