/*      Compiler: ECL 24.5.10                                         */
/*      Source: /builddir/build/BUILD/ecl-24.5.10-build/ecl-24.5.10/src/cmp/cmppass1-eval.lsp */
#include <ecl/ecl-cmp.h>
#include "cmp/cmppass1-eval.eclh"
/*      function definition for C1EXPR-INNER                          */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3445c1expr_inner(cl_object v1form)
{
 cl_object T0, T1;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  if (!(ECL_SYMBOLP(v1form))) { goto L1; }
  v1form = L3456chk_symbol_macrolet(v1form);
  if (ECL_SYMBOLP(v1form)) { goto L5; }
  value0 = v1form;
  cl_env_copy->nvalues = 1;
  return value0;
L5:;
  if (!((v1form)==(ECL_NIL))) { goto L7; }
  value0 = L3447c1nil();
  return value0;
L7:;
  if (!((v1form)==(ECL_T))) { goto L9; }
  value0 = L3448c1t();
  return value0;
L9:;
  if (Null(cl_keywordp(v1form))) { goto L11; }
  T0 = ecl_function_dispatch(cl_env_copy,VV[47])(1, v1form) /*  OBJECT-TYPE */;
  T1 = ecl_function_dispatch(cl_env_copy,VV[48])(1, v1form) /*  ADD-SYMBOL */;
  value0 = ecl_function_dispatch(cl_env_copy,VV[49])(5, VV[0], ECL_SYM("TYPE",1353), T0, VV[1], T1) /*  MAKE-C1FORM* */;
  return value0;
L11:;
  {
   cl_object v2;
   if (Null(cl_constantp(2, v1form, ecl_symbol_value(VV[2])))) { goto L15; }
   T0 = cl_symbol_value(v1form);
   v2 = L3457c1constant_value(1, T0);
   goto L13;
L15:;
   v2 = ECL_NIL;
   goto L13;
L13:;
   if (Null(v2)) { goto L17; }
   value0 = v2;
   cl_env_copy->nvalues = 1;
   return value0;
L17:;
   value0 = ecl_function_dispatch(cl_env_copy,VV[50])(1, v1form) /*  C1VAR */;
   return value0;
  }
L1:;
  if (!(ECL_CONSP(v1form))) { goto L19; }
  if ((si_proper_list_p(v1form))!=ECL_NIL) { goto L21; }
  ecl_function_dispatch(cl_env_copy,VV[51])(2, VV[3], v1form) /*  CMPERR */;
L21:;
  {
   cl_object v3fun;
   v3fun = ecl_car(v1form);
   {
    cl_object v4fd;
    v4fd = ecl_gethash_safe(v3fun,ecl_symbol_value(VV[4]),ECL_NIL);
    if (Null(v4fd)) { goto L24; }
    v3fun = v4fd;
    if (Null(v3fun)) { goto L24; }
   }
   T0 = ecl_cdr(v1form);
   value0 = ecl_function_dispatch(cl_env_copy,v3fun)(1, T0);
   return value0;
L24:;
   if (!(ECL_SYMBOLP(v3fun))) { goto L29; }
   T0 = ecl_cdr(v1form);
   value0 = ecl_function_dispatch(cl_env_copy,VV[52])(3, v3fun, T0, ECL_T) /*  C1CALL */;
   return value0;
L29:;
   if (!(ECL_CONSP(v3fun))) { goto L31; }
   T0 = ecl_car(v3fun);
   if (!((T0)==(ECL_SYM("LAMBDA",454)))) { goto L31; }
   value0 = ecl_function_dispatch(cl_env_copy,VV[53])(1, v1form) /*  C1FUNCALL */;
   return value0;
L31:;
   value0 = ecl_function_dispatch(cl_env_copy,VV[51])(2, VV[5], v3fun) /*  CMPERR */;
   return value0;
  }
L19:;
  value0 = L3457c1constant_value(3, v1form, VV[6], ECL_T);
  return value0;
 }
}
/*      function definition for C1EXPR                                */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3446c1expr(cl_object v1form)
{
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  ecl_bds_bind(cl_env_copy,VV[7],v1form);         /*  *CURRENT-FORM*  */
L1:;
  v1form = L3445c1expr_inner(v1form);
  if (Null(ecl_function_dispatch(cl_env_copy,VV[55])(1, v1form) /*  C1FORM-P */)) { goto L2; }
  value0 = v1form;
  cl_env_copy->nvalues = 1;
  ecl_bds_unwind1(cl_env_copy);
  return value0;
L2:;
  goto L1;
 }
}
/*      function definition for C1NIL                                 */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3447c1nil()
{
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  value0 = ecl_symbol_value(VV[9]);
  cl_env_copy->nvalues = 1;
  return value0;
 }
}
/*      function definition for C1T                                   */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3448c1t()
{
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  value0 = ecl_symbol_value(VV[11]);
  cl_env_copy->nvalues = 1;
  return value0;
 }
}
/*      function definition for C1WITH-BACKEND                        */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3449c1with_backend(cl_object v1forms)
{
 cl_object T0, T1;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v2tag;
   v2tag = ECL_NIL;
   {
    cl_object v3form;
    v3form = ECL_NIL;
    {
     cl_object v4;
     cl_object v5;
     v4 = ecl_list1(ECL_NIL);
     v5 = v4;
L6:;
     {
      cl_object v6;
      v6 = v1forms;
      {
       cl_object v7;
       v7 = v6;
       {
        bool v8;
        v8 = ECL_LISTP(v7);
        if (ecl_unlikely(!(v8)))
         FEwrong_type_argument(VV[13],v7);
        value0 = ECL_NIL;
        cl_env_copy->nvalues = 0;
       }
      }
      if (Null(v6)) { goto L14; }
      {
       cl_object v7;
       v7 = ECL_CONS_CDR(v6);
       v1forms = v7;
       v6 = ECL_CONS_CAR(v6);
      }
L14:;
      v2tag = v6;
     }
     {
      cl_object v6;
      v6 = v1forms;
      {
       cl_object v7;
       v7 = v6;
       {
        bool v8;
        v8 = ECL_LISTP(v7);
        if (ecl_unlikely(!(v8)))
         FEwrong_type_argument(VV[13],v7);
        value0 = ECL_NIL;
        cl_env_copy->nvalues = 0;
       }
      }
      if (Null(v6)) { goto L26; }
      {
       cl_object v7;
       v7 = ECL_CONS_CDR(v6);
       v1forms = v7;
       v6 = ECL_CONS_CAR(v6);
      }
L26:;
      v3form = v6;
     }
     if ((v2tag)!=ECL_NIL) { goto L32; }
     goto L7;
L32:;
     if (!((v2tag)==(ECL_SYM("C/C++",1869)))) { goto L34; }
     {
      cl_object v6;
      v6 = v5;
      if (ecl_unlikely(ECL_ATOM(v6))) FEtype_error_cons(v6);
      value0 = ECL_NIL;
      cl_env_copy->nvalues = 0;
      T1 = v6;
     }
     v5 = ecl_list1(v3form);
     (ECL_CONS_CDR(T1)=v5,T1);
L34:;
     goto L6;
L7:;
     T0 = ecl_cdr(v4);
     goto L1;
    }
   }
  }
L1:;
  value0 = L3450c1progn(T0);
  return value0;
 }
}
/*      function definition for C1PROGN                               */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3450c1progn(cl_object v1forms)
{
 cl_object T0, T1;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  if (!(ecl_endp(v1forms))) { goto L1; }
  value0 = ecl_function_dispatch(cl_env_copy,VV[60])(1, ECL_NIL) /*  T1/C1EXPR */;
  return value0;
L1:;
  T0 = ecl_cdr(v1forms);
  if (!(ecl_endp(T0))) { goto L3; }
  T0 = ecl_car(v1forms);
  value0 = ecl_function_dispatch(cl_env_copy,VV[60])(1, T0) /*  T1/C1EXPR */;
  return value0;
L3:;
  {
   cl_object v2fl;
   cl_object v3output_form;
   cl_object v4output_type;
   {
    cl_object v5;
    v5 = ecl_fdefinition(VV[60]);
    {
     cl_object v6;
     cl_object v7;
     v6 = ECL_NIL;
     {
      cl_object v8;
      v8 = v1forms;
      if (ecl_unlikely(!ECL_LISTP(v8))) FEtype_error_list(v8);
      value0 = ECL_NIL;
      cl_env_copy->nvalues = 0;
      v7 = v8;
     }
     {
      cl_object v8;
      cl_object v9;
      v8 = ecl_list1(ECL_NIL);
      v9 = v8;
L13:;
      if (!(ecl_endp(v7))) { goto L15; }
      goto L14;
L15:;
      v6 = ECL_CONS_CAR(v7);
      {
       cl_object v10;
       v10 = ECL_CONS_CDR(v7);
       if (ecl_unlikely(!ECL_LISTP(v10))) FEtype_error_list(v10);
       value0 = ECL_NIL;
       cl_env_copy->nvalues = 0;
       v7 = v10;
      }
      {
       cl_object v10;
       v10 = v9;
       if (ecl_unlikely(ECL_ATOM(v10))) FEtype_error_cons(v10);
       value0 = ECL_NIL;
       cl_env_copy->nvalues = 0;
       T0 = v10;
      }
      T1 = ecl_function_dispatch(cl_env_copy,v5)(1, v6);
      v9 = ecl_list1(T1);
      (ECL_CONS_CDR(T0)=v9,T0);
      goto L13;
L14:;
      v2fl = ecl_cdr(v8);
      goto L5;
     }
    }
   }
L5:;
   T0 = ecl_last(v2fl,1);
   v3output_form = ecl_car(T0);
   if (Null(v3output_form)) { goto L34; }
   v4output_type = ecl_function_dispatch(cl_env_copy,VV[61])(1, v3output_form) /*  C1FORM-TYPE */;
   goto L32;
L34:;
   v4output_type = ECL_NIL;
   goto L32;
L32:;
   value0 = ecl_function_dispatch(cl_env_copy,VV[49])(5, ECL_SYM("PROGN",673), ECL_SYM("TYPE",1353), v4output_type, VV[1], v2fl) /*  MAKE-C1FORM* */;
   return value0;
  }
 }
}
/*      function definition for C1ARGS*                               */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3451c1args_(cl_object v1forms)
{
 cl_object T0, T1;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v2;
   v2 = ecl_fdefinition(VV[8]);
   {
    cl_object v3;
    cl_object v4;
    v3 = ECL_NIL;
    {
     cl_object v5;
     v5 = v1forms;
     if (ecl_unlikely(!ECL_LISTP(v5))) FEtype_error_list(v5);
     value0 = ECL_NIL;
     cl_env_copy->nvalues = 0;
     v4 = v5;
    }
    {
     cl_object v5;
     cl_object v6;
     v5 = ecl_list1(ECL_NIL);
     v6 = v5;
L8:;
     if (!(ecl_endp(v4))) { goto L10; }
     goto L9;
L10:;
     v3 = ECL_CONS_CAR(v4);
     {
      cl_object v7;
      v7 = ECL_CONS_CDR(v4);
      if (ecl_unlikely(!ECL_LISTP(v7))) FEtype_error_list(v7);
      value0 = ECL_NIL;
      cl_env_copy->nvalues = 0;
      v4 = v7;
     }
     {
      cl_object v7;
      v7 = v6;
      if (ecl_unlikely(ECL_ATOM(v7))) FEtype_error_cons(v7);
      value0 = ECL_NIL;
      cl_env_copy->nvalues = 0;
      T0 = v7;
     }
     T1 = ecl_function_dispatch(cl_env_copy,v2)(1, v3);
     v6 = ecl_list1(T1);
     (ECL_CONS_CDR(T0)=v6,T0);
     goto L8;
L9:;
     value0 = ecl_cdr(v5);
     cl_env_copy->nvalues = 1;
     return value0;
    }
   }
  }
 }
}
/*      function definition for C1DECL-BODY                           */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3452c1decl_body(cl_object v1decls, cl_object v2body)
{
 cl_object T0, T1, T2;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  if (!(v1decls==ECL_NIL)) { goto L1; }
  value0 = L3450c1progn(v2body);
  return value0;
L1:;
  T0 = ecl_fdefinition(VV[64]);
  T1 = ecl_function_dispatch(cl_env_copy,VV[65])(1, ecl_symbol_value(VV[2])) /*  CMP-ENV-COPY */;
  T2 = cl_reduce(4, T0, v1decls, VV[17], T1);
  ecl_bds_bind(cl_env_copy,VV[2],T2);             /*  *CMP-ENV*       */
  value0 = L3450c1progn(v2body);
  ecl_bds_unwind1(cl_env_copy);
  return value0;
 }
}
/*      function definition for C1LOCALLY                             */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3453c1locally(cl_object v1args)
{
 cl_object T0;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;                                  /*  BODY            */
   cl_object v4;                                  /*  SS              */
   cl_object v5;                                  /*  TS              */
   cl_object v6;                                  /*  IS              */
   cl_object v7;                                  /*  OTHER-DECL      */
   value0 = ecl_function_dispatch(cl_env_copy,VV[67])(2, v1args, ECL_T) /*  C1BODY */;
   {
    const int v8 = cl_env_copy->nvalues;
    v3 = value0;
    cl_object v9;
    v9 = (v8<=1)? ECL_NIL : cl_env_copy->values[1];
    v4 = v9;
    v9 = (v8<=2)? ECL_NIL : cl_env_copy->values[2];
    v5 = v9;
    v9 = (v8<=3)? ECL_NIL : cl_env_copy->values[3];
    v6 = v9;
    v9 = (v8<=4)? ECL_NIL : cl_env_copy->values[4];
    v7 = v9;
   }
   if ((v4)!=ECL_NIL) { goto L4; }
   if ((v5)!=ECL_NIL) { goto L4; }
   if ((v6)!=ECL_NIL) { goto L4; }
   if (Null(v7)) { goto L2; }
   goto L3;
L4:;
L3:;
   T0 = ecl_function_dispatch(cl_env_copy,VV[65])(0) /*  CMP-ENV-COPY */;
   ecl_bds_bind(cl_env_copy,VV[2],T0);            /*  *CMP-ENV*       */
   {
    cl_object v8;
    v8 = ecl_fdefinition(VV[68]);
    {
     cl_object v9;
     cl_object v10;
     v9 = ECL_NIL;
     {
      cl_object v11;
      v11 = v4;
      if (ecl_unlikely(!ECL_LISTP(v11))) FEtype_error_list(v11);
      value0 = ECL_NIL;
      cl_env_copy->nvalues = 0;
      v10 = v11;
     }
L14:;
     if (!(ecl_endp(v10))) { goto L16; }
     goto L15;
L16:;
     v9 = ECL_CONS_CAR(v10);
     {
      cl_object v11;
      v11 = ECL_CONS_CDR(v10);
      if (ecl_unlikely(!ECL_LISTP(v11))) FEtype_error_list(v11);
      value0 = ECL_NIL;
      cl_env_copy->nvalues = 0;
      v10 = v11;
     }
     ecl_function_dispatch(cl_env_copy,v8)(1, v9);
     goto L14;
L15:;
     goto L8;
    }
   }
L8:;
   ecl_function_dispatch(cl_env_copy,VV[69])(3, ECL_NIL, v5, v6) /*  CHECK-VDECL */;
   value0 = L3452c1decl_body(v7, v3);
   ecl_bds_unwind1(cl_env_copy);
   return value0;
L2:;
   value0 = L3450c1progn(v3);
   return value0;
  }
 }
}
/*      function definition for C1MACROLET                            */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3454c1macrolet(cl_object v1args)
{
 cl_object T0, T1, T2;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  ecl_function_dispatch(cl_env_copy,VV[71])(3, ECL_SYM("MACROLET",523), v1args, ecl_make_fixnum(1)) /*  CHECK-ARGS-NUMBER */;
  T0 = ecl_car(v1args);
  T1 = ecl_function_dispatch(cl_env_copy,VV[65])(0) /*  CMP-ENV-COPY  */;
  T2 = ecl_function_dispatch(cl_env_copy,ECL_SYM("CMP-ENV-REGISTER-MACROLET",1673))(2, T0, T1) /*  CMP-ENV-REGISTER-MACROLET */;
  ecl_bds_bind(cl_env_copy,VV[2],T2);             /*  *CMP-ENV*       */
  T0 = ecl_cdr(v1args);
  value0 = L3453c1locally(T0);
  ecl_bds_unwind1(cl_env_copy);
  return value0;
 }
}
/*      function definition for C1SYMBOL-MACROLET                     */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3455c1symbol_macrolet(cl_object v1args)
{
 cl_object T0;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  ecl_function_dispatch(cl_env_copy,VV[71])(3, ECL_SYM("SYMBOL-MACROLET",844), v1args, ecl_make_fixnum(1)) /*  CHECK-ARGS-NUMBER */;
  T0 = ecl_function_dispatch(cl_env_copy,VV[65])(0) /*  CMP-ENV-COPY  */;
  ecl_bds_bind(cl_env_copy,VV[2],T0);             /*  *CMP-ENV*       */
  {
   cl_object v2;
   v2 = ecl_car(v1args);
   goto L6;
L5:;
   {
    cl_object v3def;
    v3def = ecl_car(v2);
    {
     cl_object v4name;
     v4name = ecl_car(v3def);
     if (ecl_endp(v3def)) { goto L14; }
     if (!(ECL_SYMBOLP(v4name))) { goto L14; }
     T0 = ecl_cdr(v3def);
     if (!(ecl_endp(T0))) { goto L12; }
     goto L13;
L14:;
L13:;
     ecl_function_dispatch(cl_env_copy,VV[51])(2, VV[21], v3def) /*  CMPERR */;
L12:;
     T0 = ecl_cadr(v3def);
     ecl_function_dispatch(cl_env_copy,VV[73])(2, v4name, T0) /*  CMP-ENV-REGISTER-SYMBOL-MACRO */;
    }
   }
   v2 = ecl_cdr(v2);
L6:;
   if (Null(v2)) { goto L19; }
   goto L5;
L19:;
  }
  T0 = ecl_cdr(v1args);
  value0 = L3453c1locally(T0);
  ecl_bds_unwind1(cl_env_copy);
  return value0;
 }
}
/*      function definition for CHK-SYMBOL-MACROLET                   */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3456chk_symbol_macrolet(cl_object v1form)
{
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
L1:;
  if (ECL_SYMBOLP(v1form)) { goto L3; }
  value0 = v1form;
  cl_env_copy->nvalues = 1;
  return value0;
L3:;
  {
   cl_object v2new_form;
   v2new_form = cl_macroexpand_1(2, v1form, ecl_symbol_value(VV[2]));
   if (!((v2new_form)==(v1form))) { goto L6; }
   value0 = v1form;
   cl_env_copy->nvalues = 1;
   return value0;
L6:;
   v1form = v2new_form;
  }
  goto L1;
 }
}
/*      function definition for C1CONSTANT-VALUE                      */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3457c1constant_value(cl_narg narg, cl_object v1val, ...)
{
 cl_object T0, T1;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 if (ecl_unlikely(narg<1)) FEwrong_num_arguments_anonym();
 {
  cl_object v2always;
  ecl_va_list args; ecl_va_start(args,v1val,narg,1);
  {
   cl_object keyvars[2];
   cl_parse_key(args,1,L3457c1constant_valuekeys,keyvars,NULL,FALSE);
   ecl_va_end(args);
   v2always = keyvars[0];
  }
  {
   cl_object v3;
   {
    cl_object v4x;
    {
     cl_object v5;
     cl_object v6;
     cl_object v7;
     v5 = ecl_symbol_value(VV[24]);
     v6 = v1val;
     v7 = v5;
     v4x = ecl_assql(v6,v7);
    }
    if (Null(v4x)) { goto L6; }
    cl_set(VV[25],cl_adjoin(2, VV[26], ecl_symbol_value(VV[25])));
    cl_set(VV[25],cl_adjoin(2, VV[27], ecl_symbol_value(VV[25])));
    v4x = ecl_cdr(v4x);
    if (!(ECL_LISTP(v4x))) { goto L14; }
    v3 = L3446c1expr(v4x);
    goto L1;
L14:;
    v3 = v4x;
    goto L1;
L6:;
    v3 = ECL_NIL;
   }
L1:;
   if (Null(v3)) { goto L16; }
   value0 = v3;
   cl_env_copy->nvalues = 1;
   return value0;
L16:;
   if (!((v1val)==(ECL_NIL))) { goto L18; }
   value0 = L3447c1nil();
   return value0;
L18:;
   if (!((v1val)==(ECL_T))) { goto L20; }
   value0 = L3448c1t();
   return value0;
L20:;
   if (!(ECL_FIXNUMP(v1val))) { goto L22; }
   T0 = cl_list(2, VV[28], v1val);
   value0 = ecl_function_dispatch(cl_env_copy,VV[49])(5, VV[0], ECL_SYM("TYPE",1353), ECL_SYM("FIXNUM",374), VV[1], T0) /*  MAKE-C1FORM* */;
   return value0;
L22:;
   if (!(ECL_CHARACTERP(v1val))) { goto L24; }
   T0 = cl_char_code(v1val);
   T1 = cl_list(2, VV[29], T0);
   value0 = ecl_function_dispatch(cl_env_copy,VV[49])(5, VV[0], ECL_SYM("TYPE",1353), ECL_SYM("CHARACTER",224), VV[1], T1) /*  MAKE-C1FORM* */;
   return value0;
L24:;
   if (!(ECL_DOUBLE_FLOAT_P(v1val))) { goto L26; }
   T0 = ecl_function_dispatch(cl_env_copy,VV[76])(1, v1val) /*  ADD-OBJECT */;
   T1 = cl_list(3, VV[30], v1val, T0);
   value0 = ecl_function_dispatch(cl_env_copy,VV[49])(5, VV[0], ECL_SYM("TYPE",1353), ECL_SYM("DOUBLE-FLOAT",317), VV[1], T1) /*  MAKE-C1FORM* */;
   return value0;
L26:;
   if (!(ECL_SINGLE_FLOAT_P(v1val))) { goto L28; }
   T0 = ecl_function_dispatch(cl_env_copy,VV[76])(1, v1val) /*  ADD-OBJECT */;
   T1 = cl_list(3, VV[31], v1val, T0);
   value0 = ecl_function_dispatch(cl_env_copy,VV[49])(5, VV[0], ECL_SYM("TYPE",1353), ECL_SYM("SINGLE-FLOAT",780), VV[1], T1) /*  MAKE-C1FORM* */;
   return value0;
L28:;
   if (!(ECL_LONG_FLOAT_P(v1val))) { goto L30; }
   T0 = ecl_function_dispatch(cl_env_copy,VV[76])(1, v1val) /*  ADD-OBJECT */;
   T1 = cl_list(3, VV[32], v1val, T0);
   value0 = ecl_function_dispatch(cl_env_copy,VV[49])(5, VV[0], ECL_SYM("TYPE",1353), ECL_SYM("LONG-FLOAT",510), VV[1], T1) /*  MAKE-C1FORM* */;
   return value0;
L30:;
   if (Null(v2always)) { goto L32; }
   T0 = cl_list(2, ECL_SYM("EQL",336), v1val);
   T1 = ecl_function_dispatch(cl_env_copy,VV[76])(1, v1val) /*  ADD-OBJECT */;
   value0 = ecl_function_dispatch(cl_env_copy,VV[49])(5, VV[0], ECL_SYM("TYPE",1353), T0, VV[1], T1) /*  MAKE-C1FORM* */;
   return value0;
L32:;
   value0 = ECL_NIL;
   cl_env_copy->nvalues = 1;
   return value0;
  }
 }
}
/*      function definition for C1IF                                  */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3458c1if(cl_object v1args)
{
 cl_object T0, T1, T2;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  ecl_function_dispatch(cl_env_copy,VV[71])(4, ECL_SYM("IF",948), v1args, ecl_make_fixnum(2), ecl_make_fixnum(3)) /*  CHECK-ARGS-NUMBER */;
  {
   cl_object v2test;
   T0 = ecl_car(v1args);
   v2test = L3446c1expr(T0);
   {
    cl_object v4;                                 /*  CONSTANT-P      */
    cl_object v5;                                 /*  VALUE           */
    value0 = ecl_function_dispatch(cl_env_copy,VV[78])(1, v2test) /*  C1FORM-CONSTANT-P */;
    {
     const int v6 = cl_env_copy->nvalues;
     v4 = value0;
     cl_object v7;
     v7 = (v6<=1)? ECL_NIL : cl_env_copy->values[1];
     v5 = v7;
    }
    if (Null(v4)) { goto L3; }
    if (Null(v5)) { goto L6; }
    value0 = ecl_cadr(v1args);
    cl_env_copy->nvalues = 1;
    return value0;
L6:;
    value0 = ecl_caddr(v1args);
    cl_env_copy->nvalues = 1;
    return value0;
   }
L3:;
   {
    cl_object v3true_branch;
    cl_object v4false_branch;
    T0 = ecl_cadr(v1args);
    v3true_branch = L3446c1expr(T0);
    T0 = ecl_caddr(v1args);
    v4false_branch = L3446c1expr(T0);
    T0 = ecl_function_dispatch(cl_env_copy,VV[61])(1, v3true_branch) /*  C1FORM-TYPE */;
    T1 = ecl_function_dispatch(cl_env_copy,VV[61])(1, v4false_branch) /*  C1FORM-TYPE */;
    T2 = ecl_function_dispatch(cl_env_copy,VV[79])(2, T0, T1) /*  VALUES-TYPE-OR */;
    value0 = ecl_function_dispatch(cl_env_copy,VV[49])(7, ECL_SYM("IF",948), ECL_SYM("TYPE",1353), T2, VV[1], v2test, v3true_branch, v4false_branch) /*  MAKE-C1FORM* */;
    return value0;
   }
  }
 }
}
/*      function definition for C1NOT                                 */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3459c1not(cl_object v1args)
{
 cl_object T0;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  ecl_function_dispatch(cl_env_copy,VV[71])(4, ECL_SYM("NOT",586), v1args, ecl_make_fixnum(1), ecl_make_fixnum(1)) /*  CHECK-ARGS-NUMBER */;
  {
   cl_object v2value;
   T0 = ecl_car(v1args);
   v2value = L3446c1expr(T0);
   {
    cl_object v4;                                 /*  CONSTANT-P      */
    cl_object v5;                                 /*  VALUE           */
    value0 = ecl_function_dispatch(cl_env_copy,VV[78])(1, v2value) /*  C1FORM-CONSTANT-P */;
    {
     const int v6 = cl_env_copy->nvalues;
     v4 = value0;
     cl_object v7;
     v7 = (v6<=1)? ECL_NIL : cl_env_copy->values[1];
     v5 = v7;
    }
    if (Null(v4)) { goto L3; }
    value0 = Null(v5)?ECL_T:ECL_NIL;
    cl_env_copy->nvalues = 1;
    return value0;
   }
L3:;
   value0 = ecl_function_dispatch(cl_env_copy,VV[49])(5, VV[35], ECL_SYM("TYPE",1353), VV[36], VV[1], v2value) /*  MAKE-C1FORM* */;
   return value0;
  }
 }
}
/*      function definition for C1AND                                 */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3460c1and(cl_object v1args)
{
 cl_object T0, T1;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  if (!(v1args==ECL_NIL)) { goto L1; }
  value0 = L3448c1t();
  return value0;
L1:;
  {
   cl_object v2values;
   cl_object v3last;
   cl_object v4butlast;
   v2values = L3451c1args_(v1args);
   T0 = ecl_last(v2values,1);
   v3last = ecl_car(T0);
   v4butlast = ecl_nbutlast(v2values,1);
   if (Null(v4butlast)) { goto L6; }
   T0 = ecl_function_dispatch(cl_env_copy,VV[82])(1, v3last) /*  C1FORM-PRIMARY-TYPE */;
   T1 = ecl_function_dispatch(cl_env_copy,VV[83])(2, ECL_SYM("NULL",607), T0) /*  TYPE-OR */;
   value0 = ecl_function_dispatch(cl_env_copy,VV[49])(6, VV[38], ECL_SYM("TYPE",1353), T1, VV[1], v4butlast, v3last) /*  MAKE-C1FORM* */;
   return value0;
L6:;
   value0 = v3last;
   cl_env_copy->nvalues = 1;
   return value0;
  }
 }
}
/*      function definition for C1OR                                  */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3461c1or(cl_object v1args)
{
 cl_object T0, T1, T2, T3;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  if (!(v1args==ECL_NIL)) { goto L1; }
  value0 = L3447c1nil();
  return value0;
L1:;
  {
   cl_object v2values;
   cl_object v3last;
   cl_object v4butlast;
   v2values = L3451c1args_(v1args);
   T0 = ecl_last(v2values,1);
   v3last = ecl_car(T0);
   v4butlast = ecl_butlast(v2values,1);
   if (Null(v4butlast)) { goto L6; }
   T0 = ecl_fdefinition(VV[83]);
   T1 = ecl_fdefinition(VV[82]);
   T2 = ecl_function_dispatch(cl_env_copy,VV[82])(1, v3last) /*  C1FORM-PRIMARY-TYPE */;
   T3 = cl_reduce(6, T0, v4butlast, ECL_SYM("KEY",1294), T1, VV[17], T2);
   value0 = ecl_function_dispatch(cl_env_copy,VV[49])(6, VV[40], ECL_SYM("TYPE",1353), T3, VV[1], v4butlast, v3last) /*  MAKE-C1FORM* */;
   return value0;
L6:;
   value0 = v3last;
   cl_env_copy->nvalues = 1;
   return value0;
  }
 }
}
/*      function definition for C1MULTIPLE-VALUE-PROG1                */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3462c1multiple_value_prog1(cl_object v1args)
{
 cl_object T0, T1, T2, T3, T4, T5;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  ecl_function_dispatch(cl_env_copy,VV[71])(3, ECL_SYM("MULTIPLE-VALUE-PROG1",577), v1args, ecl_make_fixnum(1)) /*  CHECK-ARGS-NUMBER */;
  {
   cl_object v2frame;
   v2frame = cl_gensym(0);
   T0 = ecl_car(v1args);
   T1 = cl_list(3, VV[43], v2frame, T0);
   T2 = ecl_cdr(v1args);
   T3 = cl_list(2, VV[44], v2frame);
   T4 = ecl_list1(T3);
   T5 = ecl_append(T2,T4);
   value0 = cl_listX(4, VV[42], v2frame, T1, T5);
   return value0;
  }
 }
}
/*      function definition for C1VALUES                              */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3463c1values(cl_object v1args)
{
 cl_object T0;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  T0 = L3451c1args_(v1args);
  value0 = ecl_function_dispatch(cl_env_copy,VV[49])(3, ECL_SYM("VALUES",897), VV[1], T0) /*  MAKE-C1FORM* */;
  return value0;
 }
}

#include "cmp/cmppass1-eval.data"
#ifdef __cplusplus
extern "C"
#endif
ECL_DLLEXPORT void _ecl4Cfvx8SWd5Nj9_Sfg7vD71(cl_object flag)
{
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 cl_object *VVtemp;
 if (flag != OBJNULL){
 Cblock = flag;
 #ifndef ECL_DYNAMIC_VV
 flag->cblock.data = VV;
 #endif
 flag->cblock.data_size = VM;
 flag->cblock.temp_data_size = VMtemp;
 flag->cblock.data_text = compiler_data_text;
 flag->cblock.cfuns_size = compiler_cfuns_size;
 flag->cblock.cfuns = compiler_cfuns;
 flag->cblock.source = ecl_make_constant_base_string("SRC:CMP;CMPPASS1-EVAL.LSP.NEWEST",-1);
 return;}
 #ifdef ECL_DYNAMIC_VV
 VV = Cblock->cblock.data;
 #endif
 Cblock->cblock.data_text = (const cl_object *)"@EcLtAg:_ecl4Cfvx8SWd5Nj9_Sfg7vD71@";
 VVtemp = Cblock->cblock.temp_data;
 ECL_DEFINE_SETF_FUNCTIONS
  si_select_package(_ecl_static_0);
  (void)0; /* No entry created for C1EXPR-INNER */
  ecl_cmp_defun(VV[54]);                          /*  C1EXPR          */
 {
  cl_object T0;
  cl_object volatile env0 = ECL_NIL;
  si_Xmake_special(VV[9]);
  if (ecl_boundp(cl_env_copy,VV[9])) { goto L9; }
  T0 = ecl_function_dispatch(cl_env_copy,VV[47])(1, ECL_NIL) /*  OBJECT-TYPE */;
  cl_set(VV[9],ecl_function_dispatch(cl_env_copy,VV[49])(5, VV[0], ECL_SYM("TYPE",1353), T0, VV[1], ECL_NIL) /*  MAKE-C1FORM* */);
L9:;
 }
  ecl_cmp_defun(VV[56]);                          /*  C1NIL           */
 {
  cl_object T0;
  cl_object volatile env0 = ECL_NIL;
  si_Xmake_special(VV[11]);
  if (ecl_boundp(cl_env_copy,VV[11])) { goto L19; }
  T0 = ecl_function_dispatch(cl_env_copy,VV[47])(1, ECL_T) /*  OBJECT-TYPE */;
  cl_set(VV[11],ecl_function_dispatch(cl_env_copy,VV[49])(5, VV[0], ECL_SYM("TYPE",1353), T0, VV[1], ECL_T) /*  MAKE-C1FORM* */);
L19:;
 }
  ecl_cmp_defun(VV[57]);                          /*  C1T             */
  ecl_cmp_defun(VV[58]);                          /*  C1WITH-BACKEND  */
  ecl_cmp_defun(VV[59]);                          /*  C1PROGN         */
  ecl_cmp_defun(VV[62]);                          /*  C1ARGS*         */
  ecl_cmp_defun(VV[63]);                          /*  C1DECL-BODY     */
  ecl_cmp_defun(VV[66]);                          /*  C1LOCALLY       */
  ecl_cmp_defun(VV[70]);                          /*  C1MACROLET      */
  ecl_cmp_defun(VV[72]);                          /*  C1SYMBOL-MACROLET */
  ecl_cmp_defun(VV[74]);                          /*  CHK-SYMBOL-MACROLET */
  ecl_cmp_defun(VV[75]);                          /*  C1CONSTANT-VALUE */
  ecl_cmp_defun(VV[77]);                          /*  C1IF            */
  ecl_cmp_defun(VV[80]);                          /*  C1NOT           */
  ecl_cmp_defun(VV[81]);                          /*  C1AND           */
  ecl_cmp_defun(VV[84]);                          /*  C1OR            */
  ecl_cmp_defun(VV[85]);                          /*  C1MULTIPLE-VALUE-PROG1 */
  ecl_cmp_defun(VV[86]);                          /*  C1VALUES        */
}
