/*      Compiler: ECL 24.5.10                                         */
/*      Source: /builddir/build/BUILD/ecl-24.5.10-build/ecl-24.5.10/src/cmp/cmparray.lsp */
#include <ecl/ecl-cmp.h>
#include "cmp/cmparray.eclh"
/*      function definition for VALID-ARRAY-INDEX-P                   */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3984valid_array_index_p(cl_object v1x)
{
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_fixnum v2;
   v2 = 0;
   if (!(ECL_FIXNUMP(v1x))) { goto L3; }
   v2 = ecl_fixnum(v1x);
   if (!((v2)<=(2305843009213693950))) { goto L8; }
   value0 = ecl_make_bool((v2)>=(0));
   cl_env_copy->nvalues = 1;
   return value0;
L8:;
   value0 = ECL_NIL;
   cl_env_copy->nvalues = 1;
   return value0;
L3:;
   value0 = ECL_NIL;
   cl_env_copy->nvalues = 1;
   return value0;
  }
 }
}
/*      function definition for GUESS-ARRAY-ELEMENT-TYPE              */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3985guess_array_element_type(cl_object v1element_type)
{
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  v1element_type = ecl_function_dispatch(cl_env_copy,VV[49])(1, v1element_type) /*  EXTRACT-CONSTANT-VALUE */;
  if (Null(v1element_type)) { goto L1; }
  if (Null(ecl_function_dispatch(cl_env_copy,VV[50])(1, v1element_type) /*  KNOWN-TYPE-P */)) { goto L1; }
  value0 = cl_upgraded_array_element_type(1, v1element_type);
  return value0;
L1:;
  value0 = ECL_SYM("*",20);
  cl_env_copy->nvalues = 1;
  return value0;
 }
}
/*      function definition for GUESS-ARRAY-DIMENSIONS-TYPE           */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3986guess_array_dimensions_type(cl_object v1orig_dimensions)
{
 cl_object T0;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  if (!(ECL_CONSP(v1orig_dimensions))) { goto L3; }
  T0 = ecl_car(ECL_NIL);
  if (!((T0)==(ECL_SYM("LIST",483)))) { goto L3; }
  {
   cl_object v2l;
   v2l = cl_list_length(v1orig_dimensions);
   if (Null(v2l)) { goto L1; }
   if (Null(cl_L(3, ecl_make_fixnum(-1), v2l, ecl_make_fixnum(64)))) { goto L1; }
   T0 = ecl_one_minus(v2l);
   value0 = cl_make_list(3, T0, ECL_SYM("INITIAL-ELEMENT",1283), ECL_SYM("*",20));
   return value0;
  }
L3:;
  goto L1;
L1:;
  {
   cl_object v2dimensions;
   v2dimensions = ecl_function_dispatch(cl_env_copy,VV[49])(2, v1orig_dimensions, VV[2]) /*  EXTRACT-CONSTANT-VALUE */;
   if (!((v2dimensions)==(VV[2]))) { goto L10; }
   value0 = ECL_SYM("*",20);
   cl_env_copy->nvalues = 1;
   return value0;
L10:;
   if (Null(L3984valid_array_index_p(v2dimensions))) { goto L12; }
   value0 = ecl_list1(v2dimensions);
   cl_env_copy->nvalues = 1;
   return value0;
L12:;
   if (!(ECL_LISTP(v2dimensions))) { goto L14; }
   {
    cl_object v3rank;
    v3rank = cl_list_length(v2dimensions);
    if (ecl_numberp(v3rank)) { goto L18; }
    if ((cl_L(3, ecl_make_fixnum(-1), v3rank, ecl_make_fixnum(64)))!=ECL_NIL) { goto L18; }
    T0 = ecl_fdefinition(VV[52]);
    if (Null(cl_every(2, T0, v2dimensions))) { goto L14; }
    goto L15;
L18:;
   }
L15:;
   value0 = v2dimensions;
   cl_env_copy->nvalues = 1;
   return value0;
L14:;
   ecl_function_dispatch(cl_env_copy,VV[53])(2, VV[3], v1orig_dimensions) /*  CMPWARN */;
   value0 = ECL_SYM("*",20);
   cl_env_copy->nvalues = 1;
   return value0;
  }
 }
}
/*      local function LAMBDA22                                       */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC3987__lambda22(cl_object v1, cl_object v2)
{
 cl_object T0;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4dimensions;
   T0 = ecl_car(v1);
   if (!((T0)==(ECL_SYM("FUNCALL",396)))) { goto L2; }
   T0 = ecl_caadr(v1);
   if (!((T0)==(ECL_SYM("FUNCTION",398)))) { goto L2; }
   v3 = ecl_cddr(v1);
   goto L1;
L2:;
   v3 = ecl_cdr(v1);
L1:;
   if (!(v3==ECL_NIL)) { goto L6; }
   ecl_function_dispatch(cl_env_copy,VV[54])(1, v1) /*  DM-TOO-FEW-ARGUMENTS */;
L6:;
   {
    cl_object v5;
    v5 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4dimensions = v5;
   }
   {
    cl_object v5;
    cl_object v6;
    cl_object v7form;
    cl_object v8_dimensions;
    cl_object v9_element_type;
    cl_object v10element_type;
    cl_object v11;
    cl_object v12_initial_element;
    cl_object v13initial_element;
    cl_object v14initial_element_supplied_p;
    cl_object v15_initial_contents;
    cl_object v16initial_contents;
    cl_object v17initial_contents_supplied_p;
    cl_object v18_adjustable;
    cl_object v19adjustable;
    cl_object v20;
    cl_object v21_fill_pointer;
    cl_object v22fill_pointer;
    cl_object v23;
    cl_object v24_displaced_to;
    cl_object v25displaced_to;
    cl_object v26;
    cl_object v27_displaced_index_offset;
    cl_object v28displaced_index_offset;
    cl_object v29;
    v5 = ECL_NIL;
    v6 = ECL_NIL;
    v7form = v1;
    v8_dimensions = cl_gensym(0);
    v9_element_type = cl_gensym(0);
    v10element_type = ECL_T;
    v11 = ECL_NIL;
    v12_initial_element = cl_gensym(0);
    v13initial_element = ECL_NIL;
    v14initial_element_supplied_p = ECL_NIL;
    v15_initial_contents = cl_gensym(0);
    v16initial_contents = ECL_NIL;
    v17initial_contents_supplied_p = ECL_NIL;
    v18_adjustable = cl_gensym(0);
    v19adjustable = ECL_NIL;
    v20 = ECL_NIL;
    v21_fill_pointer = cl_gensym(0);
    v22fill_pointer = ECL_NIL;
    v23 = ECL_NIL;
    v24_displaced_to = cl_gensym(0);
    v25displaced_to = ECL_NIL;
    v26 = ECL_NIL;
    v27_displaced_index_offset = cl_gensym(0);
    v28displaced_index_offset = ecl_make_fixnum(0);
    v29 = ECL_NIL;
    {
     cl_fixnum v30;
     v30 = ecl_length(v3);
     {
      cl_fixnum v31;
      v31 = (v30>=0&&2>0?(v30)%(2):ecl_imod(v30,2));
      if ((v31)==0) { goto L37; }
     }
    }
    value0 = v1;
    cl_env_copy->nvalues = 1;
    return value0;
L37:;
    {
     cl_object v30;
     cl_object v31;
     v30 = ECL_NIL;
     {
      cl_object v32;
      v32 = v3;
      if (ecl_unlikely(!ECL_LISTP(v32))) FEtype_error_list(v32);
      value0 = ECL_NIL;
      cl_env_copy->nvalues = 0;
      v31 = v32;
     }
     {
      cl_object v32;
      cl_object v33;
      cl_object v34;
      v32 = ecl_cdr(v3);
      v33 = ECL_NIL;
      {
       cl_object v35;
       v35 = v32;
       if (ecl_unlikely(!ECL_LISTP(v35))) FEtype_error_list(v35);
       value0 = ECL_NIL;
       cl_env_copy->nvalues = 0;
       v34 = v35;
      }
      {
       cl_object v35;
       v35 = ECL_NIL;
L49:;
       if (!(ecl_endp(v31))) { goto L51; }
       goto L50;
L51:;
       v30 = ECL_CONS_CAR(v31);
       {
        cl_object v36;
        v36 = ecl_cddr(v31);
        if (ecl_unlikely(!ECL_LISTP(v36))) FEtype_error_list(v36);
        value0 = ECL_NIL;
        cl_env_copy->nvalues = 0;
        v31 = v36;
       }
       if (!(ecl_endp(v34))) { goto L59; }
       goto L50;
L59:;
       v33 = ECL_CONS_CAR(v34);
       {
        cl_object v36;
        v36 = ecl_cddr(v34);
        if (ecl_unlikely(!ECL_LISTP(v36))) FEtype_error_list(v36);
        value0 = ECL_NIL;
        cl_env_copy->nvalues = 0;
        v34 = v36;
       }
       v35 = ECL_NIL;
       if (Null(cl_keywordp(v30))) { goto L72; }
       if (!((v30)==(ECL_SYM("ALLOW-OTHER-KEYS",1224)))) { goto L70; }
       goto L71;
L72:;
L71:;
       value0 = v1;
       cl_env_copy->nvalues = 1;
       return value0;
L70:;
       if (!((v30)==(ECL_SYM("DISPLACED-INDEX-OFFSET",1248)))) { goto L74; }
       if ((v29)!=ECL_NIL) { goto L74; }
       v35 = ECL_T;
       v28displaced_index_offset = v33;
       v29 = ECL_T;
       v6 = CONS(ECL_SYM("DISPLACED-INDEX-OFFSET",1248),v6);
L74:;
       if (!((v30)==(ECL_SYM("DISPLACED-TO",1249)))) { goto L84; }
       if ((v26)!=ECL_NIL) { goto L84; }
       v35 = ECL_T;
       v25displaced_to = v33;
       v26 = ECL_T;
       v6 = CONS(ECL_SYM("DISPLACED-TO",1249),v6);
L84:;
       if (!((v30)==(ECL_SYM("FILL-POINTER",1267)))) { goto L94; }
       if ((v23)!=ECL_NIL) { goto L94; }
       v35 = ECL_T;
       v22fill_pointer = v33;
       v23 = ECL_T;
       v6 = CONS(ECL_SYM("FILL-POINTER",1267),v6);
L94:;
       if (!((v30)==(ECL_SYM("ADJUSTABLE",1221)))) { goto L104; }
       if ((v20)!=ECL_NIL) { goto L104; }
       v35 = ECL_T;
       v19adjustable = v33;
       v20 = ECL_T;
       v6 = CONS(ECL_SYM("ADJUSTABLE",1221),v6);
L104:;
       if (!((v30)==(ECL_SYM("INITIAL-CONTENTS",1284)))) { goto L114; }
       if ((v17initial_contents_supplied_p)!=ECL_NIL) { goto L114; }
       v35 = ECL_T;
       v16initial_contents = v33;
       v17initial_contents_supplied_p = ECL_T;
       v6 = CONS(ECL_SYM("INITIAL-CONTENTS",1284),v6);
L114:;
       if (!((v30)==(ECL_SYM("INITIAL-ELEMENT",1283)))) { goto L124; }
       if ((v14initial_element_supplied_p)!=ECL_NIL) { goto L124; }
       v35 = ECL_T;
       v13initial_element = v33;
       v14initial_element_supplied_p = ECL_T;
       v6 = CONS(ECL_SYM("INITIAL-ELEMENT",1283),v6);
L124:;
       if (!((v30)==(ECL_SYM("ELEMENT-TYPE",1252)))) { goto L134; }
       if ((v11)!=ECL_NIL) { goto L134; }
       v35 = ECL_T;
       v10element_type = v33;
       v11 = ECL_T;
       v6 = CONS(ECL_SYM("ELEMENT-TYPE",1252),v6);
L134:;
       if ((v35)!=ECL_NIL) { goto L69; }
       value0 = v1;
       cl_env_copy->nvalues = 1;
       return value0;
L69:;
       goto L49;
L50:;
      }
     }
    }
    {
     cl_object v30;
     {
      cl_object v31dimensions_type;
      cl_object v32guessed_element_type;
      v31dimensions_type = L3986guess_array_dimensions_type(v4dimensions);
      v32guessed_element_type = L3985guess_array_element_type(v10element_type);
      if ((v17initial_contents_supplied_p)!=ECL_NIL) { goto L147; }
      if ((v32guessed_element_type)==(ECL_SYM("*",20))) { goto L151; }
      v10element_type = cl_list(2, ECL_SYM("QUOTE",681), v32guessed_element_type);
L151:;
      {
       cl_object v33function;
       v33function = ECL_SYM("MAKE-PURE-ARRAY",1110);
       if (!(ECL_LISTP(v31dimensions_type))) { goto L156; }
       T0 = ecl_cdr(v31dimensions_type);
       if (!(T0==ECL_NIL)) { goto L156; }
       T0 = ecl_car(v31dimensions_type);
       if (!(ECL_FIXNUMP(T0)||ECL_BIGNUMP(T0))) { goto L156; }
       v33function = ECL_SYM("MAKE-VECTOR",1113);
       v4dimensions = ecl_car(v31dimensions_type);
L156:;
       v7form = cl_list(7, v33function, v9_element_type, v8_dimensions, v18_adjustable, v21_fill_pointer, v24_displaced_to, v27_displaced_index_offset);
      }
      if (Null(v14initial_element_supplied_p)) { goto L164; }
      v7form = cl_listX(4, ECL_SYM("FILL-ARRAY-WITH-ELT",1774), v7form, v12_initial_element, VV[5]);
L164:;
      T0 = cl_list(3, ECL_SYM("ARRAY",98), v32guessed_element_type, v31dimensions_type);
      v7form = cl_list(3, ECL_SYM("TRULY-THE",2073), T0, v7form);
     }
L147:;
     v30 = v7form;
     if (!((v30)==(v1))) { goto L168; }
     value0 = v1;
     cl_env_copy->nvalues = 1;
     return value0;
L168:;
     T0 = cl_list(2, v8_dimensions, v4dimensions);
     v5 = CONS(T0,v5);
     {
      cl_object v31;
      cl_object v32;
      cl_object v33;
      v31 = cl_nreverse(v6);
      v32 = ECL_NIL;
      {
       cl_object v34;
       v34 = v31;
       if (ecl_unlikely(!ECL_LISTP(v34))) FEtype_error_list(v34);
       value0 = ECL_NIL;
       cl_env_copy->nvalues = 0;
       v33 = v34;
      }
L178:;
      if (!(ecl_endp(v33))) { goto L180; }
      goto L179;
L180:;
      v32 = ECL_CONS_CAR(v33);
      {
       cl_object v34;
       v34 = ECL_CONS_CDR(v33);
       if (ecl_unlikely(!ECL_LISTP(v34))) FEtype_error_list(v34);
       value0 = ECL_NIL;
       cl_env_copy->nvalues = 0;
       v33 = v34;
      }
      if (!((v32)==(ECL_SYM("DISPLACED-INDEX-OFFSET",1248)))) { goto L189; }
      T0 = cl_list(2, v27_displaced_index_offset, v28displaced_index_offset);
      v5 = CONS(T0,v5);
L189:;
      if (!((v32)==(ECL_SYM("DISPLACED-TO",1249)))) { goto L192; }
      T0 = cl_list(2, v24_displaced_to, v25displaced_to);
      v5 = CONS(T0,v5);
L192:;
      if (!((v32)==(ECL_SYM("FILL-POINTER",1267)))) { goto L195; }
      T0 = cl_list(2, v21_fill_pointer, v22fill_pointer);
      v5 = CONS(T0,v5);
L195:;
      if (!((v32)==(ECL_SYM("ADJUSTABLE",1221)))) { goto L198; }
      T0 = cl_list(2, v18_adjustable, v19adjustable);
      v5 = CONS(T0,v5);
L198:;
      if (!((v32)==(ECL_SYM("INITIAL-CONTENTS",1284)))) { goto L201; }
      T0 = cl_list(2, v15_initial_contents, v16initial_contents);
      v5 = CONS(T0,v5);
L201:;
      if (!((v32)==(ECL_SYM("INITIAL-ELEMENT",1283)))) { goto L204; }
      T0 = cl_list(2, v12_initial_element, v13initial_element);
      v5 = CONS(T0,v5);
L204:;
      if (!((v32)==(ECL_SYM("ELEMENT-TYPE",1252)))) { goto L188; }
      T0 = cl_list(2, v9_element_type, v10element_type);
      v5 = CONS(T0,v5);
L188:;
      goto L178;
L179:;
     }
     if ((v11)!=ECL_NIL) { goto L210; }
     T0 = cl_list(2, v9_element_type, v10element_type);
     v5 = CONS(T0,v5);
L210:;
     if ((v14initial_element_supplied_p)!=ECL_NIL) { goto L213; }
     T0 = cl_list(2, v12_initial_element, v13initial_element);
     v5 = CONS(T0,v5);
L213:;
     if ((v17initial_contents_supplied_p)!=ECL_NIL) { goto L216; }
     T0 = cl_list(2, v15_initial_contents, v16initial_contents);
     v5 = CONS(T0,v5);
L216:;
     if ((v20)!=ECL_NIL) { goto L219; }
     T0 = cl_list(2, v18_adjustable, v19adjustable);
     v5 = CONS(T0,v5);
L219:;
     if ((v23)!=ECL_NIL) { goto L222; }
     T0 = cl_list(2, v21_fill_pointer, v22fill_pointer);
     v5 = CONS(T0,v5);
L222:;
     if ((v26)!=ECL_NIL) { goto L225; }
     T0 = cl_list(2, v24_displaced_to, v25displaced_to);
     v5 = CONS(T0,v5);
L225:;
     if ((v29)!=ECL_NIL) { goto L228; }
     T0 = cl_list(2, v27_displaced_index_offset, v28displaced_index_offset);
     v5 = CONS(T0,v5);
L228:;
     T0 = cl_nreverse(v5);
     value0 = cl_list(3, ECL_SYM("LET",479), T0, v30);
     return value0;
    }
   }
  }
 }
}
/*      function definition for EXPAND-VECTOR-PUSH                    */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3988expand_vector_push(cl_object v1whole, cl_object v2env, cl_object v3extend)
{
 cl_object T0, T1, T2, T3, T4, T5, T6, T7, T8;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v4args;
   v4args = ecl_cdr(v1whole);
   T0 = ecl_car(v4args);
   if ((T0)==(VV[6])) { goto L4; }
   if ((ecl_function_dispatch(cl_env_copy,VV[55])(0) /*  POLICY-OPEN-CODE-AREF/ASET */)!=ECL_NIL) { goto L2; }
   goto L3;
L4:;
L3:;
   value0 = v1whole;
   cl_env_copy->nvalues = 1;
   return value0;
L2:;
   {
    cl_fixnum v5;
    v5 = ecl_length(v4args);
    {
     cl_fixnum v6;
     if (Null(v3extend)) { goto L9; }
     v6 = 3;
     goto L8;
L9:;
     v6 = 2;
L8:;
     if (((2)<=(v5) && (v5)<=(v6))) { goto L6; }
    }
   }
   T0 = ecl_car(v1whole);
   ecl_function_dispatch(cl_env_copy,VV[53])(3, VV[7], T0, v1whole) /*  CMPWARN */;
   T0 = ecl_car(v1whole);
   T1 = cl_list(2, ECL_SYM("QUOTE",681), T0);
   T2 = cl_list(2, ECL_SYM("QUOTE",681), v1whole);
   value0 = cl_list(4, ECL_SYM("SIMPLE-PROGRAM-ERROR",1163), VV[7], T1, T2);
   return value0;
L6:;
   T0 = ecl_car(v4args);
   T1 = cl_list(2, VV[6], T0);
   T2 = ecl_cadr(v4args);
   T3 = cl_list(2, VV[8], T2);
   T4 = cl_list(2, T1, T3);
   if (Null(v3extend)) { goto L13; }
   T6 = ecl_cddr(v4args);
   T5 = cl_listX(4, ECL_SYM("VECTOR-PUSH-EXTEND",903), VV[6], VV[8], T6);
   goto L12;
L13:;
   T5 = ECL_NIL;
L12:;
   T6 = cl_list(2, ECL_T, T5);
   T7 = cl_list(3, ECL_SYM("COND",249), VV[13], T6);
   T8 = cl_list(4, ECL_SYM("LET",479), VV[11], VV[12], T7);
   value0 = cl_list(5, ECL_SYM("LET*",480), T4, VV[9], VV[10], T8);
   return value0;
  }
 }
}
/*      local function LAMBDA84                                       */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC3989__lambda84(cl_object v1, cl_object v2env)
{
 cl_object T0;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   T0 = ecl_car(v1);
   if (!((T0)==(ECL_SYM("FUNCALL",396)))) { goto L2; }
   T0 = ecl_caadr(v1);
   if (!((T0)==(ECL_SYM("FUNCTION",398)))) { goto L2; }
   v3 = ecl_cddr(v1);
   goto L1;
L2:;
   v3 = ecl_cdr(v1);
L1:;
   value0 = L3988expand_vector_push(v1, v2env, ECL_NIL);
   return value0;
  }
 }
}
/*      local function LAMBDA87                                       */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC3990__lambda87(cl_object v1, cl_object v2env)
{
 cl_object T0;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   T0 = ecl_car(v1);
   if (!((T0)==(ECL_SYM("FUNCALL",396)))) { goto L2; }
   T0 = ecl_caadr(v1);
   if (!((T0)==(ECL_SYM("FUNCTION",398)))) { goto L2; }
   v3 = ecl_cddr(v1);
   goto L1;
L2:;
   v3 = ecl_cdr(v1);
L1:;
   value0 = L3988expand_vector_push(v1, v2env, ECL_T);
   return value0;
  }
 }
}
/*      local function LAMBDA90                                       */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC3991__lambda90(cl_object v1, cl_object v2env)
{
 cl_object T0;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4array;
   T0 = ecl_car(v1);
   if (!((T0)==(ECL_SYM("FUNCALL",396)))) { goto L2; }
   T0 = ecl_caadr(v1);
   if (!((T0)==(ECL_SYM("FUNCTION",398)))) { goto L2; }
   v3 = ecl_cddr(v1);
   goto L1;
L2:;
   v3 = ecl_cdr(v1);
L1:;
   if (!(v3==ECL_NIL)) { goto L6; }
   ecl_function_dispatch(cl_env_copy,VV[54])(1, v1) /*  DM-TOO-FEW-ARGUMENTS */;
L6:;
   {
    cl_object v5;
    v5 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4array = v5;
   }
   if (Null(ecl_function_dispatch(cl_env_copy,VV[55])(1, v2env) /*  POLICY-OPEN-CODE-AREF/ASET */)) { goto L11; }
   value0 = L3992expand_aref(v4array, v3, v2env);
   return value0;
L11:;
   value0 = v1;
   cl_env_copy->nvalues = 1;
   return value0;
  }
 }
}
/*      function definition for EXPAND-AREF                           */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3992expand_aref(cl_object v1array, cl_object v2indices, cl_object v3env)
{
 cl_object T0, T1, T2, T3;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  T0 = cl_list(2, VV[14], v1array);
  T1 = ecl_list1(T0);
  T2 = L3999expand_row_major_index(VV[14], v2indices, v3env);
  T3 = cl_list(3, ECL_SYM("ROW-MAJOR-AREF",733), VV[14], T2);
  value0 = cl_list(4, ECL_SYM("LET",479), T1, VV[15], T3);
  return value0;
 }
}
/*      local function LAMBDA94                                       */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC3993__lambda94(cl_object v1, cl_object v2env)
{
 cl_object T0;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4array;
   T0 = ecl_car(v1);
   if (!((T0)==(ECL_SYM("FUNCALL",396)))) { goto L2; }
   T0 = ecl_caadr(v1);
   if (!((T0)==(ECL_SYM("FUNCTION",398)))) { goto L2; }
   v3 = ecl_cddr(v1);
   goto L1;
L2:;
   v3 = ecl_cdr(v1);
L1:;
   if (!(v3==ECL_NIL)) { goto L6; }
   ecl_function_dispatch(cl_env_copy,VV[54])(1, v1) /*  DM-TOO-FEW-ARGUMENTS */;
L6:;
   {
    cl_object v5;
    v5 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4array = v5;
   }
   if (!(v3==ECL_NIL)) { goto L11; }
   ecl_function_dispatch(cl_env_copy,VV[53])(2, VV[17], v1) /*  CMPWARN */;
   value0 = v1;
   cl_env_copy->nvalues = 1;
   return value0;
L11:;
   if (Null(ecl_function_dispatch(cl_env_copy,VV[55])(1, v2env) /*  POLICY-OPEN-CODE-AREF/ASET */)) { goto L14; }
   {
    cl_object v5indices;
    cl_object v6value;
    v5indices = ecl_butlast(v3,1);
    T0 = ecl_last(v3,1);
    v6value = ecl_car(T0);
    value0 = L3994expand_aset(v4array, v5indices, v6value, v2env);
    return value0;
   }
L14:;
   value0 = v1;
   cl_env_copy->nvalues = 1;
   return value0;
  }
 }
}
/*      function definition for EXPAND-ASET                           */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3994expand_aset(cl_object v1array, cl_object v2indices, cl_object v3value, cl_object v4env)
{
 cl_object T0, T1, T2, T3, T4, T5;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v5_array;
   v5_array = cl_gensym(1, _ecl_static_0);
   T0 = cl_list(2, v5_array, v1array);
   T1 = ecl_list1(T0);
   T2 = cl_list(2, VV[18], v5_array);
   T3 = cl_list(3, ECL_SYM("DECLARE",276), T2, VV[19]);
   T4 = L3999expand_row_major_index(v5_array, v2indices, v4env);
   T5 = cl_list(4, ECL_SYM("ROW-MAJOR-ASET",1151), v5_array, T4, v3value);
   value0 = cl_list(4, ECL_SYM("LET*",480), T1, T3, T5);
   return value0;
  }
 }
}
/*      local function LAMBDA98                                       */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC3995__lambda98(cl_object v1, cl_object v2env)
{
 cl_object T0, T1, T2;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4array;
   T0 = ecl_car(v1);
   if (!((T0)==(ECL_SYM("FUNCALL",396)))) { goto L2; }
   T0 = ecl_caadr(v1);
   if (!((T0)==(ECL_SYM("FUNCTION",398)))) { goto L2; }
   v3 = ecl_cddr(v1);
   goto L1;
L2:;
   v3 = ecl_cdr(v1);
L1:;
   if (!(v3==ECL_NIL)) { goto L6; }
   ecl_function_dispatch(cl_env_copy,VV[54])(1, v1) /*  DM-TOO-FEW-ARGUMENTS */;
L6:;
   {
    cl_object v5;
    v5 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4array = v5;
   }
   if (Null(ecl_function_dispatch(cl_env_copy,VV[55])(1, v2env) /*  POLICY-OPEN-CODE-AREF/ASET */)) { goto L11; }
   T0 = cl_list(2, VV[21], v4array);
   T1 = ecl_list1(T0);
   T2 = L3999expand_row_major_index(VV[21], v3, v2env);
   value0 = cl_list(4, ECL_SYM("LET",479), T1, VV[22], T2);
   return value0;
L11:;
   value0 = v1;
   cl_env_copy->nvalues = 1;
   return value0;
  }
 }
}
/*      function definition for EXPAND-ZERO-DIM-INDEX-CHECK           */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3996expand_zero_dim_index_check(cl_object v1a, cl_object v2env)
{
 cl_object T0, T1;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  if (Null(ecl_function_dispatch(cl_env_copy,VV[59])(1, v2env) /*  POLICY-TYPE-ASSERTIONS */)) { goto L1; }
  T0 = cl_list(3, VV[23], v1a, ECL_SYM("ARRAY",98));
  T1 = cl_list(3, VV[24], v1a, ecl_make_fixnum(0));
  value0 = cl_list(4, ECL_SYM("PROGN",673), T0, T1, ecl_make_fixnum(0));
  return value0;
L1:;
  value0 = ecl_make_fixnum(0);
  cl_env_copy->nvalues = 1;
  return value0;
 }
}
/*      function definition for EXPAND-VECTOR-INDEX-CHECK             */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3998expand_vector_index_check(cl_object v1a, cl_object v2index, cl_object v3env)
{
 cl_object T0, T1, T2;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  if (Null(ecl_function_dispatch(cl_env_copy,VV[59])(1, v3env) /*  POLICY-TYPE-ASSERTIONS */)) { goto L1; }
  T0 = cl_list(2, VV[27], v2index);
  T1 = ecl_list1(T0);
  T2 = LC3997expansion(v1a, VV[27]);
  value0 = cl_list(4, ECL_SYM("LET",479), T1, VV[28], T2);
  return value0;
L1:;
  value0 = v2index;
  cl_env_copy->nvalues = 1;
  return value0;
 }
}
/*      local function EXPANSION                                      */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC3997expansion(cl_object v1a, cl_object v2index)
{
 cl_object T0, T1;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  T0 = cl_list(3, VV[23], v1a, ECL_SYM("VECTOR",900));
  T1 = cl_list(3, VV[26], v1a, v2index);
  value0 = cl_list(4, ECL_SYM("PROGN",673), T0, T1, v2index);
  return value0;
 }
}
/*      function definition for EXPAND-ROW-MAJOR-INDEX                */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3999expand_row_major_index(cl_object v1a, cl_object v2indices, cl_object v3env)
{
 cl_object T0, T1, T2, T3, T4, T5, T6, T7, T8, T9, T10;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  if (!(v2indices==ECL_NIL)) { goto L1; }
  value0 = L3996expand_zero_dim_index_check(v1a, v3env);
  return value0;
L1:;
  T0 = ecl_cdr(v2indices);
  if (!(T0==ECL_NIL)) { goto L3; }
  T0 = ecl_car(v2indices);
  value0 = L3998expand_vector_index_check(v1a, T0, v3env);
  return value0;
L3:;
  {
   cl_fixnum v4expected_rank;
   cl_object v5check;
   cl_object v6dims;
   cl_object v7dim_names;
   v4expected_rank = ecl_length(v2indices);
   v5check = ecl_function_dispatch(cl_env_copy,VV[62])(1, v3env) /*  POLICY-ARRAY-BOUNDS-CHECK */;
   {
    cl_object v8i;
    v8i = ecl_make_fixnum(0);
    {
     cl_object v9index;
     cl_object v10;
     v9index = ECL_NIL;
     {
      cl_object v11;
      v11 = v2indices;
      if (ecl_unlikely(!ECL_LISTP(v11))) FEtype_error_list(v11);
      value0 = ECL_NIL;
      cl_env_copy->nvalues = 0;
      v10 = v11;
     }
     {
      cl_object v11;
      cl_object v12;
      v11 = ecl_list1(ECL_NIL);
      v12 = v11;
L15:;
      if (!(ecl_endp(v10))) { goto L17; }
      goto L16;
L17:;
      v9index = ECL_CONS_CAR(v10);
      {
       cl_object v13;
       v13 = ECL_CONS_CDR(v10);
       if (ecl_unlikely(!ECL_LISTP(v13))) FEtype_error_list(v13);
       value0 = ECL_NIL;
       cl_env_copy->nvalues = 0;
       v10 = v13;
      }
      {
       cl_object v13;
       v13 = v12;
       if (ecl_unlikely(ECL_ATOM(v13))) FEtype_error_cons(v13);
       value0 = ECL_NIL;
       cl_env_copy->nvalues = 0;
       T0 = v13;
      }
      T1 = cl_gentemp(1, VV[30]);
      T2 = cl_list(3, VV[31], v1a, v8i);
      T3 = cl_list(2, T1, T2);
      v12 = ecl_list1(T3);
      (ECL_CONS_CDR(T0)=v12,T0);
      v8i = ecl_one_plus(v8i);
      goto L15;
L16:;
      v6dims = ecl_cdr(v11);
      goto L7;
     }
    }
   }
L7:;
   {
    cl_object v8;
    v8 = (ECL_SYM("FIRST",373)->symbol.gfdef);
    {
     cl_object v9;
     cl_object v10;
     v9 = ECL_NIL;
     {
      cl_object v11;
      v11 = v6dims;
      if (ecl_unlikely(!ECL_LISTP(v11))) FEtype_error_list(v11);
      value0 = ECL_NIL;
      cl_env_copy->nvalues = 0;
      v10 = v11;
     }
     {
      cl_object v11;
      cl_object v12;
      v11 = ecl_list1(ECL_NIL);
      v12 = v11;
L42:;
      if (!(ecl_endp(v10))) { goto L44; }
      goto L43;
L44:;
      v9 = ECL_CONS_CAR(v10);
      {
       cl_object v13;
       v13 = ECL_CONS_CDR(v10);
       if (ecl_unlikely(!ECL_LISTP(v13))) FEtype_error_list(v13);
       value0 = ECL_NIL;
       cl_env_copy->nvalues = 0;
       v10 = v13;
      }
      {
       cl_object v13;
       v13 = v12;
       if (ecl_unlikely(ECL_ATOM(v13))) FEtype_error_cons(v13);
       value0 = ECL_NIL;
       cl_env_copy->nvalues = 0;
       T0 = v13;
      }
      T1 = ecl_function_dispatch(cl_env_copy,v8)(1, v9);
      v12 = ecl_list1(T1);
      (ECL_CONS_CDR(T0)=v12,T0);
      goto L42;
L43:;
      v7dim_names = ecl_cdr(v11);
      goto L34;
     }
    }
   }
L34:;
   T0 = ecl_append(v6dims,VV[32]);
   T1 = cl_listX(4, ECL_SYM("TYPE",871), ECL_SYM("ARRAY-INDEX",1870), VV[33], v7dim_names);
   T2 = CONS(ECL_SYM("IGNORABLE",429),v7dim_names);
   T3 = cl_list(3, ECL_SYM("DECLARE",276), T1, T2);
   if (Null(ecl_function_dispatch(cl_env_copy,VV[59])(1, v3env) /*  POLICY-TYPE-ASSERTIONS */)) { goto L61; }
   T5 = cl_list(3, VV[23], v1a, ECL_SYM("ARRAY",98));
   T6 = cl_list(3, VV[24], v1a, ecl_make_fixnum(v4expected_rank));
   T4 = cl_list(2, T5, T6);
   goto L60;
L61:;
   T4 = ECL_NIL;
L60:;
   {
    cl_object v8i;
    v8i = ecl_make_fixnum(0);
    {
     cl_object v9l;
     cl_object v10;
     v9l = ECL_NIL;
     {
      cl_object v11;
      v11 = v2indices;
      if (ecl_unlikely(!ECL_LISTP(v11))) FEtype_error_list(v11);
      value0 = ECL_NIL;
      cl_env_copy->nvalues = 0;
      v10 = v11;
     }
     {
      cl_object v11index;
      cl_object v12;
      v11index = ECL_NIL;
      {
       cl_object v13;
       v13 = v2indices;
       if (ecl_unlikely(!ECL_LISTP(v13))) FEtype_error_list(v13);
       value0 = ECL_NIL;
       cl_env_copy->nvalues = 0;
       v12 = v13;
      }
      {
       cl_object v13dim_var;
       cl_object v14;
       v13dim_var = ECL_NIL;
       {
        cl_object v15;
        v15 = v7dim_names;
        if (ecl_unlikely(!ECL_LISTP(v15))) FEtype_error_list(v15);
        value0 = ECL_NIL;
        cl_env_copy->nvalues = 0;
        v14 = v15;
       }
       {
        cl_object v15;
        cl_object v16;
        v15 = ecl_list1(ECL_NIL);
        v16 = v15;
L79:;
        if (!(ecl_endp(v10))) { goto L81; }
        goto L80;
L81:;
        v9l = ECL_CONS_CAR(v10);
        {
         cl_object v17;
         v17 = ECL_CONS_CDR(v10);
         if (ecl_unlikely(!ECL_LISTP(v17))) FEtype_error_list(v17);
         value0 = ECL_NIL;
         cl_env_copy->nvalues = 0;
         v10 = v17;
        }
        if (!(ecl_endp(v12))) { goto L89; }
        goto L80;
L89:;
        v11index = ECL_CONS_CAR(v12);
        {
         cl_object v17;
         v17 = ECL_CONS_CDR(v12);
         if (ecl_unlikely(!ECL_LISTP(v17))) FEtype_error_list(v17);
         value0 = ECL_NIL;
         cl_env_copy->nvalues = 0;
         v12 = v17;
        }
        if (!(ecl_endp(v14))) { goto L97; }
        goto L80;
L97:;
        v13dim_var = ECL_CONS_CAR(v14);
        {
         cl_object v17;
         v17 = ECL_CONS_CDR(v14);
         if (ecl_unlikely(!ECL_LISTP(v17))) FEtype_error_list(v17);
         value0 = ECL_NIL;
         cl_env_copy->nvalues = 0;
         v14 = v17;
        }
        if (!(ecl_plusp(v8i))) { goto L105; }
        {
         cl_object v17;
         v17 = v16;
         if (ecl_unlikely(ECL_ATOM(v17))) FEtype_error_cons(v17);
         value0 = ECL_NIL;
         cl_env_copy->nvalues = 0;
         T6 = v17;
        }
        T7 = cl_list(3, ECL_SYM("*",20), VV[33], v13dim_var);
        T8 = cl_list(3, ECL_SYM("TRULY-THE",2073), ECL_SYM("ARRAY-INDEX",1870), T7);
        T9 = cl_list(3, ECL_SYM("SETF",752), VV[33], T8);
        v16 = ecl_list1(T9);
        (ECL_CONS_CDR(T6)=v16,T6);
L105:;
        {
         cl_object v17;
         v17 = v16;
         if (ecl_unlikely(ECL_ATOM(v17))) FEtype_error_cons(v17);
         value0 = ECL_NIL;
         cl_env_copy->nvalues = 0;
         T6 = v17;
        }
        T7 = cl_list(2, VV[34], v11index);
        T8 = ecl_list1(T7);
        if (Null(v5check)) { goto L118; }
        T9 = cl_list(4, VV[36], v1a, VV[34], v13dim_var);
        goto L116;
L118:;
        T9 = ECL_NIL;
        goto L116;
L116:;
        T10 = cl_list(5, ECL_SYM("LET",479), T8, VV[35], T9, VV[37]);
        v16 = ecl_list1(T10);
        (ECL_CONS_CDR(T6)=v16,T6);
        v8i = ecl_one_plus(v8i);
        goto L79;
L80:;
        T5 = ecl_cdr(v15);
        goto L63;
       }
      }
     }
    }
   }
L63:;
   T6 = cl_append(3, T4, T5, VV[38]);
   value0 = cl_listX(4, ECL_SYM("LET*",480), T0, T3, T6);
   return value0;
  }
 }
}
/*      local function CHECK-EXPECTED-RANK                            */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC4000check_expected_rank(cl_object v1, cl_object v2)
{
 cl_object T0;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4a;
   cl_object v5expected_rank;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   ecl_function_dispatch(cl_env_copy,VV[54])(1, v1) /*  DM-TOO-FEW-ARGUMENTS */;
L3:;
   {
    cl_object v6;
    v6 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4a = v6;
   }
   if (!(v3==ECL_NIL)) { goto L9; }
   ecl_function_dispatch(cl_env_copy,VV[54])(1, v1) /*  DM-TOO-FEW-ARGUMENTS */;
L9:;
   {
    cl_object v6;
    v6 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v5expected_rank = v6;
   }
   if (Null(v3)) { goto L14; }
   ecl_function_dispatch(cl_env_copy,VV[64])(1, v1) /*  DM-TOO-MANY-ARGUMENTS */;
L14:;
   T0 = cl_list(2, v4a, v5expected_rank);
   value0 = cl_listX(3, ECL_SYM("C-INLINE",2097), T0, VV[40]);
   return value0;
  }
 }
}
/*      local function CHECK-INDEX-IN-BOUNDS                          */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC4001check_index_in_bounds(cl_object v1, cl_object v2)
{
 cl_object T0;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4array;
   cl_object v5index;
   cl_object v6limit;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   ecl_function_dispatch(cl_env_copy,VV[54])(1, v1) /*  DM-TOO-FEW-ARGUMENTS */;
L3:;
   {
    cl_object v7;
    v7 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4array = v7;
   }
   if (!(v3==ECL_NIL)) { goto L9; }
   ecl_function_dispatch(cl_env_copy,VV[54])(1, v1) /*  DM-TOO-FEW-ARGUMENTS */;
L9:;
   {
    cl_object v7;
    v7 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v5index = v7;
   }
   if (!(v3==ECL_NIL)) { goto L15; }
   ecl_function_dispatch(cl_env_copy,VV[54])(1, v1) /*  DM-TOO-FEW-ARGUMENTS */;
L15:;
   {
    cl_object v7;
    v7 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v6limit = v7;
   }
   if (Null(v3)) { goto L20; }
   ecl_function_dispatch(cl_env_copy,VV[64])(1, v1) /*  DM-TOO-MANY-ARGUMENTS */;
L20:;
   T0 = cl_list(3, v4array, v5index, v6limit);
   value0 = cl_listX(3, ECL_SYM("C-INLINE",2097), T0, VV[41]);
   return value0;
  }
 }
}
/*      local function CHECK-VECTOR-IN-BOUNDS                         */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC4002check_vector_in_bounds(cl_object v1, cl_object v2)
{
 cl_object T0;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4vector;
   cl_object v5index;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   ecl_function_dispatch(cl_env_copy,VV[54])(1, v1) /*  DM-TOO-FEW-ARGUMENTS */;
L3:;
   {
    cl_object v6;
    v6 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4vector = v6;
   }
   if (!(v3==ECL_NIL)) { goto L9; }
   ecl_function_dispatch(cl_env_copy,VV[54])(1, v1) /*  DM-TOO-FEW-ARGUMENTS */;
L9:;
   {
    cl_object v6;
    v6 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v5index = v6;
   }
   if (Null(v3)) { goto L14; }
   ecl_function_dispatch(cl_env_copy,VV[64])(1, v1) /*  DM-TOO-MANY-ARGUMENTS */;
L14:;
   T0 = cl_list(2, v4vector, v5index);
   value0 = cl_listX(3, ECL_SYM("C-INLINE",2097), T0, VV[42]);
   return value0;
  }
 }
}
/*      function definition for ARRAY-DIMENSION-ACCESSOR              */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L4003array_dimension_accessor(cl_object v1array, cl_object v2n)
{
 cl_object T0, T1, T2;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  T0 = ecl_list1(v1array);
  {
   cl_object v3;
   v3 = VV[44];
   T2 = v3;
   {
    cl_fixnum v4;
    {
     cl_object v5;
     v5 = v2n;
     if (ecl_unlikely((ecl_fixnum(v5))>=(v3)->vector.dim))
           FEwrong_index(ECL_NIL,v3,-1,ecl_make_fixnum(ecl_fixnum(v5)),(v3)->vector.dim);
     value0 = ECL_NIL;
     cl_env_copy->nvalues = 0;
     v4 = ecl_fixnum(v5);
    }
    T1 = ecl_aref_unsafe(T2,v4);
   }
  }
  value0 = cl_listX(3, ECL_SYM("C-INLINE",2097), T0, T1);
  return value0;
 }
}
/*      local function ARRAY-DIMENSION-FAST                           */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC4004array_dimension_fast(cl_object v1, cl_object v2)
{
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4array;
   cl_object v5n;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   ecl_function_dispatch(cl_env_copy,VV[54])(1, v1) /*  DM-TOO-FEW-ARGUMENTS */;
L3:;
   {
    cl_object v6;
    v6 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4array = v6;
   }
   if (!(v3==ECL_NIL)) { goto L9; }
   ecl_function_dispatch(cl_env_copy,VV[54])(1, v1) /*  DM-TOO-FEW-ARGUMENTS */;
L9:;
   {
    cl_object v6;
    v6 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v5n = v6;
   }
   if (Null(v3)) { goto L14; }
   ecl_function_dispatch(cl_env_copy,VV[64])(1, v1) /*  DM-TOO-MANY-ARGUMENTS */;
L14:;
   {
    cl_fixnum v6;
    v6 = 0;
    if (!(ECL_FIXNUMP(v5n))) { goto L16; }
    v6 = ecl_fixnum(v5n);
    if (!((v6)<=(63))) { goto L16; }
    if (!((v6)>=(0))) { goto L16; }
   }
   value0 = L4003array_dimension_accessor(v4array, v5n);
   return value0;
L16:;
   value0 = cl_error(2, VV[46], v5n);
   return value0;
  }
 }
}

#include "cmp/cmparray.data"
#ifdef __cplusplus
extern "C"
#endif
ECL_DLLEXPORT void _eclyAYbFZVhwSOm9_kGn7vD71(cl_object flag)
{
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 cl_object *VVtemp;
 if (flag != OBJNULL){
 Cblock = flag;
 #ifndef ECL_DYNAMIC_VV
 flag->cblock.data = VV;
 #endif
 flag->cblock.data_size = VM;
 flag->cblock.temp_data_size = VMtemp;
 flag->cblock.data_text = compiler_data_text;
 flag->cblock.cfuns_size = compiler_cfuns_size;
 flag->cblock.cfuns = compiler_cfuns;
 flag->cblock.source = ecl_make_constant_base_string("SRC:CMP;CMPARRAY.LSP.NEWEST",-1);
 return;}
 #ifdef ECL_DYNAMIC_VV
 VV = Cblock->cblock.data;
 #endif
 Cblock->cblock.data_text = (const cl_object *)"@EcLtAg:_eclyAYbFZVhwSOm9_kGn7vD71@";
 VVtemp = Cblock->cblock.temp_data;
 ECL_DEFINE_SETF_FUNCTIONS
  si_select_package(VVtemp[0]);
  ecl_cmp_defun(VV[47]);                          /*  VALID-ARRAY-INDEX-P */
  ecl_cmp_defun(VV[48]);                          /*  GUESS-ARRAY-ELEMENT-TYPE */
  ecl_cmp_defun(VV[51]);                          /*  GUESS-ARRAY-DIMENSIONS-TYPE */
 {
  cl_object T0;
  cl_object volatile env0 = ECL_NIL;
  {
   cl_object volatile v1;
   v1 = ecl_make_cfun((cl_objectfn_fixed)LC3987__lambda22,ECL_NIL,Cblock,2);
   T0 = v1;
  }
  si_put_sysprop(ECL_SYM("MAKE-ARRAY",524), ECL_SYM("COMPILER-MACRO",240), T0);
 }
  (void)0; /* No entry created for EXPAND-VECTOR-PUSH */
 {
  cl_object T0;
  cl_object volatile env0 = ECL_NIL;
  {
   cl_object volatile v1;
   v1 = ecl_make_cfun((cl_objectfn_fixed)LC3989__lambda84,ECL_NIL,Cblock,2);
   T0 = v1;
  }
  si_put_sysprop(ECL_SYM("VECTOR-PUSH",902), ECL_SYM("COMPILER-MACRO",240), T0);
 }
 {
  cl_object T0;
  cl_object volatile env0 = ECL_NIL;
  {
   cl_object volatile v1;
   v1 = ecl_make_cfun((cl_objectfn_fixed)LC3990__lambda87,ECL_NIL,Cblock,2);
   T0 = v1;
  }
  si_put_sysprop(ECL_SYM("VECTOR-PUSH-EXTEND",903), ECL_SYM("COMPILER-MACRO",240), T0);
 }
 {
  cl_object T0;
  cl_object volatile env0 = ECL_NIL;
  {
   cl_object volatile v1;
   v1 = ecl_make_cfun((cl_objectfn_fixed)LC3991__lambda90,ECL_NIL,Cblock,2);
   T0 = v1;
  }
  si_put_sysprop(ECL_SYM("AREF",94), ECL_SYM("COMPILER-MACRO",240), T0);
 }
  ecl_cmp_defun(VV[56]);                          /*  EXPAND-AREF     */
 {
  cl_object T0;
  cl_object volatile env0 = ECL_NIL;
  {
   cl_object volatile v1;
   v1 = ecl_make_cfun((cl_objectfn_fixed)LC3993__lambda94,ECL_NIL,Cblock,2);
   T0 = v1;
  }
  si_put_sysprop(ECL_SYM("ASET",1043), ECL_SYM("COMPILER-MACRO",240), T0);
 }
  ecl_cmp_defun(VV[57]);                          /*  EXPAND-ASET     */
 {
  cl_object T0;
  cl_object volatile env0 = ECL_NIL;
  {
   cl_object volatile v1;
   v1 = ecl_make_cfun((cl_objectfn_fixed)LC3995__lambda98,ECL_NIL,Cblock,2);
   T0 = v1;
  }
  si_put_sysprop(ECL_SYM("ARRAY-ROW-MAJOR-INDEX",108), ECL_SYM("COMPILER-MACRO",240), T0);
 }
  ecl_cmp_defun(VV[58]);                          /*  EXPAND-ZERO-DIM-INDEX-CHECK */
  ecl_cmp_defun(VV[60]);                          /*  EXPAND-VECTOR-INDEX-CHECK */
  ecl_cmp_defun(VV[61]);                          /*  EXPAND-ROW-MAJOR-INDEX */
  ecl_cmp_defmacro(VV[63]);                       /*  CHECK-EXPECTED-RANK */
  ecl_cmp_defmacro(VV[65]);                       /*  CHECK-INDEX-IN-BOUNDS */
  ecl_cmp_defmacro(VV[66]);                       /*  CHECK-VECTOR-IN-BOUNDS */
  si_Xmake_constant(VV[43], VVtemp[1]);
  ecl_cmp_defun(VV[67]);                          /*  ARRAY-DIMENSION-ACCESSOR */
  ecl_cmp_defmacro(VV[68]);                       /*  ARRAY-DIMENSION-FAST */
}
